(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('antd'), require('react-dom')) :
	typeof define === 'function' && define.amd ? define(['exports', 'react', 'antd', 'react-dom'], factory) :
	(global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.EchartsReadymadeBar = {}, global.React$4, global.antd, global.reactDom));
})(this, (function (exports, React$4, antd, reactDom) { 'use strict';

	function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

	var React__default = /*#__PURE__*/_interopDefaultLegacy(React$4);

	function getDefaultExportFromCjs (x) {
		return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
	}

	function getAugmentedNamespace(n) {
		if (n.__esModule) return n;
		var a = Object.defineProperty({}, '__esModule', {value: true});
		Object.keys(n).forEach(function (k) {
			var d = Object.getOwnPropertyDescriptor(n, k);
			Object.defineProperty(a, k, d.get ? d : {
				enumerable: true,
				get: function () {
					return n[k];
				}
			});
		});
		return a;
	}

	var clone = {exports: {}};

	(function (module) {
	var clone = (function() {

	function _instanceof(obj, type) {
	  return type != null && obj instanceof type;
	}

	var nativeMap;
	try {
	  nativeMap = Map;
	} catch(_) {
	  // maybe a reference error because no `Map`. Give it a dummy value that no
	  // value will ever be an instanceof.
	  nativeMap = function() {};
	}

	var nativeSet;
	try {
	  nativeSet = Set;
	} catch(_) {
	  nativeSet = function() {};
	}

	var nativePromise;
	try {
	  nativePromise = Promise;
	} catch(_) {
	  nativePromise = function() {};
	}

	/**
	 * Clones (copies) an Object using deep copying.
	 *
	 * This function supports circular references by default, but if you are certain
	 * there are no circular references in your object, you can save some CPU time
	 * by calling clone(obj, false).
	 *
	 * Caution: if `circular` is false and `parent` contains circular references,
	 * your program may enter an infinite loop and crash.
	 *
	 * @param `parent` - the object to be cloned
	 * @param `circular` - set to true if the object to be cloned may contain
	 *    circular references. (optional - true by default)
	 * @param `depth` - set to a number if the object is only to be cloned to
	 *    a particular depth. (optional - defaults to Infinity)
	 * @param `prototype` - sets the prototype to be used when cloning an object.
	 *    (optional - defaults to parent prototype).
	 * @param `includeNonEnumerable` - set to true if the non-enumerable properties
	 *    should be cloned as well. Non-enumerable properties on the prototype
	 *    chain will be ignored. (optional - false by default)
	*/
	function clone(parent, circular, depth, prototype, includeNonEnumerable) {
	  if (typeof circular === 'object') {
	    depth = circular.depth;
	    prototype = circular.prototype;
	    includeNonEnumerable = circular.includeNonEnumerable;
	    circular = circular.circular;
	  }
	  // maintain two arrays for circular references, where corresponding parents
	  // and children have the same index
	  var allParents = [];
	  var allChildren = [];

	  var useBuffer = typeof Buffer != 'undefined';

	  if (typeof circular == 'undefined')
	    circular = true;

	  if (typeof depth == 'undefined')
	    depth = Infinity;

	  // recurse this function so we don't reset allParents and allChildren
	  function _clone(parent, depth) {
	    // cloning null always returns null
	    if (parent === null)
	      return null;

	    if (depth === 0)
	      return parent;

	    var child;
	    var proto;
	    if (typeof parent != 'object') {
	      return parent;
	    }

	    if (_instanceof(parent, nativeMap)) {
	      child = new nativeMap();
	    } else if (_instanceof(parent, nativeSet)) {
	      child = new nativeSet();
	    } else if (_instanceof(parent, nativePromise)) {
	      child = new nativePromise(function (resolve, reject) {
	        parent.then(function(value) {
	          resolve(_clone(value, depth - 1));
	        }, function(err) {
	          reject(_clone(err, depth - 1));
	        });
	      });
	    } else if (clone.__isArray(parent)) {
	      child = [];
	    } else if (clone.__isRegExp(parent)) {
	      child = new RegExp(parent.source, __getRegExpFlags(parent));
	      if (parent.lastIndex) child.lastIndex = parent.lastIndex;
	    } else if (clone.__isDate(parent)) {
	      child = new Date(parent.getTime());
	    } else if (useBuffer && Buffer.isBuffer(parent)) {
	      if (Buffer.allocUnsafe) {
	        // Node.js >= 4.5.0
	        child = Buffer.allocUnsafe(parent.length);
	      } else {
	        // Older Node.js versions
	        child = new Buffer(parent.length);
	      }
	      parent.copy(child);
	      return child;
	    } else if (_instanceof(parent, Error)) {
	      child = Object.create(parent);
	    } else {
	      if (typeof prototype == 'undefined') {
	        proto = Object.getPrototypeOf(parent);
	        child = Object.create(proto);
	      }
	      else {
	        child = Object.create(prototype);
	        proto = prototype;
	      }
	    }

	    if (circular) {
	      var index = allParents.indexOf(parent);

	      if (index != -1) {
	        return allChildren[index];
	      }
	      allParents.push(parent);
	      allChildren.push(child);
	    }

	    if (_instanceof(parent, nativeMap)) {
	      parent.forEach(function(value, key) {
	        var keyChild = _clone(key, depth - 1);
	        var valueChild = _clone(value, depth - 1);
	        child.set(keyChild, valueChild);
	      });
	    }
	    if (_instanceof(parent, nativeSet)) {
	      parent.forEach(function(value) {
	        var entryChild = _clone(value, depth - 1);
	        child.add(entryChild);
	      });
	    }

	    for (var i in parent) {
	      var attrs;
	      if (proto) {
	        attrs = Object.getOwnPropertyDescriptor(proto, i);
	      }

	      if (attrs && attrs.set == null) {
	        continue;
	      }
	      child[i] = _clone(parent[i], depth - 1);
	    }

	    if (Object.getOwnPropertySymbols) {
	      var symbols = Object.getOwnPropertySymbols(parent);
	      for (var i = 0; i < symbols.length; i++) {
	        // Don't need to worry about cloning a symbol because it is a primitive,
	        // like a number or string.
	        var symbol = symbols[i];
	        var descriptor = Object.getOwnPropertyDescriptor(parent, symbol);
	        if (descriptor && !descriptor.enumerable && !includeNonEnumerable) {
	          continue;
	        }
	        child[symbol] = _clone(parent[symbol], depth - 1);
	        if (!descriptor.enumerable) {
	          Object.defineProperty(child, symbol, {
	            enumerable: false
	          });
	        }
	      }
	    }

	    if (includeNonEnumerable) {
	      var allPropertyNames = Object.getOwnPropertyNames(parent);
	      for (var i = 0; i < allPropertyNames.length; i++) {
	        var propertyName = allPropertyNames[i];
	        var descriptor = Object.getOwnPropertyDescriptor(parent, propertyName);
	        if (descriptor && descriptor.enumerable) {
	          continue;
	        }
	        child[propertyName] = _clone(parent[propertyName], depth - 1);
	        Object.defineProperty(child, propertyName, {
	          enumerable: false
	        });
	      }
	    }

	    return child;
	  }

	  return _clone(parent, depth);
	}

	/**
	 * Simple flat clone using prototype, accepts only objects, usefull for property
	 * override on FLAT configuration object (no nested props).
	 *
	 * USE WITH CAUTION! This may not behave as you wish if you do not know how this
	 * works.
	 */
	clone.clonePrototype = function clonePrototype(parent) {
	  if (parent === null)
	    return null;

	  var c = function () {};
	  c.prototype = parent;
	  return new c();
	};

	// private utility functions

	function __objToStr(o) {
	  return Object.prototype.toString.call(o);
	}
	clone.__objToStr = __objToStr;

	function __isDate(o) {
	  return typeof o === 'object' && __objToStr(o) === '[object Date]';
	}
	clone.__isDate = __isDate;

	function __isArray(o) {
	  return typeof o === 'object' && __objToStr(o) === '[object Array]';
	}
	clone.__isArray = __isArray;

	function __isRegExp(o) {
	  return typeof o === 'object' && __objToStr(o) === '[object RegExp]';
	}
	clone.__isRegExp = __isRegExp;

	function __getRegExpFlags(re) {
	  var flags = '';
	  if (re.global) flags += 'g';
	  if (re.ignoreCase) flags += 'i';
	  if (re.multiline) flags += 'm';
	  return flags;
	}
	clone.__getRegExpFlags = __getRegExpFlags;

	return clone;
	})();

	if (module.exports) {
	  module.exports = clone;
	}
	}(clone));

	var cloneDeep = clone.exports;

	var MAX_DP = 1e6, MAX_POWER = 1e6, NAME = "[big.js] ", INVALID = NAME + "Invalid ", INVALID_DP = INVALID + "decimal places", INVALID_RM = INVALID + "rounding mode", DIV_BY_ZERO = NAME + "Division by zero", P = {}, UNDEFINED = void 0;
	function round(x, sd, rm, more) {
	  var xc = x.c;
	  if (rm === UNDEFINED)
	    rm = x.constructor.RM;
	  if (rm !== 0 && rm !== 1 && rm !== 2 && rm !== 3) {
	    throw Error(INVALID_RM);
	  }
	  if (sd < 1) {
	    more = rm === 3 && (more || !!xc[0]) || sd === 0 && (rm === 1 && xc[0] >= 5 || rm === 2 && (xc[0] > 5 || xc[0] === 5 && (more || xc[1] !== UNDEFINED)));
	    xc.length = 1;
	    if (more) {
	      x.e = x.e - sd + 1;
	      xc[0] = 1;
	    } else {
	      xc[0] = x.e = 0;
	    }
	  } else if (sd < xc.length) {
	    more = rm === 1 && xc[sd] >= 5 || rm === 2 && (xc[sd] > 5 || xc[sd] === 5 && (more || xc[sd + 1] !== UNDEFINED || xc[sd - 1] & 1)) || rm === 3 && (more || !!xc[0]);
	    xc.length = sd--;
	    if (more) {
	      for (; ++xc[sd] > 9; ) {
	        xc[sd] = 0;
	        if (!sd--) {
	          ++x.e;
	          xc.unshift(1);
	        }
	      }
	    }
	    for (sd = xc.length; !xc[--sd]; )
	      xc.pop();
	  }
	  return x;
	}
	function stringify(x, doExponential, isNonzero) {
	  var e = x.e, s = x.c.join(""), n = s.length;
	  if (doExponential) {
	    s = s.charAt(0) + (n > 1 ? "." + s.slice(1) : "") + (e < 0 ? "e" : "e+") + e;
	  } else if (e < 0) {
	    for (; ++e; )
	      s = "0" + s;
	    s = "0." + s;
	  } else if (e > 0) {
	    if (++e > n) {
	      for (e -= n; e--; )
	        s += "0";
	    } else if (e < n) {
	      s = s.slice(0, e) + "." + s.slice(e);
	    }
	  } else if (n > 1) {
	    s = s.charAt(0) + "." + s.slice(1);
	  }
	  return x.s < 0 && isNonzero ? "-" + s : s;
	}
	P.abs = function() {
	  var x = new this.constructor(this);
	  x.s = 1;
	  return x;
	};
	P.cmp = function(y) {
	  var isneg, x = this, xc = x.c, yc = (y = new x.constructor(y)).c, i = x.s, j = y.s, k = x.e, l = y.e;
	  if (!xc[0] || !yc[0])
	    return !xc[0] ? !yc[0] ? 0 : -j : i;
	  if (i != j)
	    return i;
	  isneg = i < 0;
	  if (k != l)
	    return k > l ^ isneg ? 1 : -1;
	  j = (k = xc.length) < (l = yc.length) ? k : l;
	  for (i = -1; ++i < j; ) {
	    if (xc[i] != yc[i])
	      return xc[i] > yc[i] ^ isneg ? 1 : -1;
	  }
	  return k == l ? 0 : k > l ^ isneg ? 1 : -1;
	};
	P.div = function(y) {
	  var x = this, Big2 = x.constructor, a = x.c, b = (y = new Big2(y)).c, k = x.s == y.s ? 1 : -1, dp = Big2.DP;
	  if (dp !== ~~dp || dp < 0 || dp > MAX_DP) {
	    throw Error(INVALID_DP);
	  }
	  if (!b[0]) {
	    throw Error(DIV_BY_ZERO);
	  }
	  if (!a[0]) {
	    y.s = k;
	    y.c = [y.e = 0];
	    return y;
	  }
	  var bl, bt, n, cmp, ri, bz = b.slice(), ai = bl = b.length, al = a.length, r = a.slice(0, bl), rl = r.length, q = y, qc = q.c = [], qi = 0, p = dp + (q.e = x.e - y.e) + 1;
	  q.s = k;
	  k = p < 0 ? 0 : p;
	  bz.unshift(0);
	  for (; rl++ < bl; )
	    r.push(0);
	  do {
	    for (n = 0; n < 10; n++) {
	      if (bl != (rl = r.length)) {
	        cmp = bl > rl ? 1 : -1;
	      } else {
	        for (ri = -1, cmp = 0; ++ri < bl; ) {
	          if (b[ri] != r[ri]) {
	            cmp = b[ri] > r[ri] ? 1 : -1;
	            break;
	          }
	        }
	      }
	      if (cmp < 0) {
	        for (bt = rl == bl ? b : bz; rl; ) {
	          if (r[--rl] < bt[rl]) {
	            ri = rl;
	            for (; ri && !r[--ri]; )
	              r[ri] = 9;
	            --r[ri];
	            r[rl] += 10;
	          }
	          r[rl] -= bt[rl];
	        }
	        for (; !r[0]; )
	          r.shift();
	      } else {
	        break;
	      }
	    }
	    qc[qi++] = cmp ? n : ++n;
	    if (r[0] && cmp)
	      r[rl] = a[ai] || 0;
	    else
	      r = [a[ai]];
	  } while ((ai++ < al || r[0] !== UNDEFINED) && k--);
	  if (!qc[0] && qi != 1) {
	    qc.shift();
	    q.e--;
	    p--;
	  }
	  if (qi > p)
	    round(q, p, Big2.RM, r[0] !== UNDEFINED);
	  return q;
	};
	P.eq = function(y) {
	  return this.cmp(y) === 0;
	};
	P.gt = function(y) {
	  return this.cmp(y) > 0;
	};
	P.gte = function(y) {
	  return this.cmp(y) > -1;
	};
	P.lt = function(y) {
	  return this.cmp(y) < 0;
	};
	P.lte = function(y) {
	  return this.cmp(y) < 1;
	};
	P.minus = P.sub = function(y) {
	  var i, j, t, xlty, x = this, Big2 = x.constructor, a = x.s, b = (y = new Big2(y)).s;
	  if (a != b) {
	    y.s = -b;
	    return x.plus(y);
	  }
	  var xc = x.c.slice(), xe = x.e, yc = y.c, ye = y.e;
	  if (!xc[0] || !yc[0]) {
	    if (yc[0]) {
	      y.s = -b;
	    } else if (xc[0]) {
	      y = new Big2(x);
	    } else {
	      y.s = 1;
	    }
	    return y;
	  }
	  if (a = xe - ye) {
	    if (xlty = a < 0) {
	      a = -a;
	      t = xc;
	    } else {
	      ye = xe;
	      t = yc;
	    }
	    t.reverse();
	    for (b = a; b--; )
	      t.push(0);
	    t.reverse();
	  } else {
	    j = ((xlty = xc.length < yc.length) ? xc : yc).length;
	    for (a = b = 0; b < j; b++) {
	      if (xc[b] != yc[b]) {
	        xlty = xc[b] < yc[b];
	        break;
	      }
	    }
	  }
	  if (xlty) {
	    t = xc;
	    xc = yc;
	    yc = t;
	    y.s = -y.s;
	  }
	  if ((b = (j = yc.length) - (i = xc.length)) > 0)
	    for (; b--; )
	      xc[i++] = 0;
	  for (b = i; j > a; ) {
	    if (xc[--j] < yc[j]) {
	      for (i = j; i && !xc[--i]; )
	        xc[i] = 9;
	      --xc[i];
	      xc[j] += 10;
	    }
	    xc[j] -= yc[j];
	  }
	  for (; xc[--b] === 0; )
	    xc.pop();
	  for (; xc[0] === 0; ) {
	    xc.shift();
	    --ye;
	  }
	  if (!xc[0]) {
	    y.s = 1;
	    xc = [ye = 0];
	  }
	  y.c = xc;
	  y.e = ye;
	  return y;
	};
	P.mod = function(y) {
	  var ygtx, x = this, Big2 = x.constructor, a = x.s, b = (y = new Big2(y)).s;
	  if (!y.c[0]) {
	    throw Error(DIV_BY_ZERO);
	  }
	  x.s = y.s = 1;
	  ygtx = y.cmp(x) == 1;
	  x.s = a;
	  y.s = b;
	  if (ygtx)
	    return new Big2(x);
	  a = Big2.DP;
	  b = Big2.RM;
	  Big2.DP = Big2.RM = 0;
	  x = x.div(y);
	  Big2.DP = a;
	  Big2.RM = b;
	  return this.minus(x.times(y));
	};
	P.plus = P.add = function(y) {
	  var e, k, t, x = this, Big2 = x.constructor;
	  y = new Big2(y);
	  if (x.s != y.s) {
	    y.s = -y.s;
	    return x.minus(y);
	  }
	  var xe = x.e, xc = x.c, ye = y.e, yc = y.c;
	  if (!xc[0] || !yc[0]) {
	    if (!yc[0]) {
	      if (xc[0]) {
	        y = new Big2(x);
	      } else {
	        y.s = x.s;
	      }
	    }
	    return y;
	  }
	  xc = xc.slice();
	  if (e = xe - ye) {
	    if (e > 0) {
	      ye = xe;
	      t = yc;
	    } else {
	      e = -e;
	      t = xc;
	    }
	    t.reverse();
	    for (; e--; )
	      t.push(0);
	    t.reverse();
	  }
	  if (xc.length - yc.length < 0) {
	    t = yc;
	    yc = xc;
	    xc = t;
	  }
	  e = yc.length;
	  for (k = 0; e; xc[e] %= 10)
	    k = (xc[--e] = xc[e] + yc[e] + k) / 10 | 0;
	  if (k) {
	    xc.unshift(k);
	    ++ye;
	  }
	  for (e = xc.length; xc[--e] === 0; )
	    xc.pop();
	  y.c = xc;
	  y.e = ye;
	  return y;
	};
	P.pow = function(n) {
	  var x = this, one = new x.constructor("1"), y = one, isneg = n < 0;
	  if (n !== ~~n || n < -MAX_POWER || n > MAX_POWER) {
	    throw Error(INVALID + "exponent");
	  }
	  if (isneg)
	    n = -n;
	  for (; ; ) {
	    if (n & 1)
	      y = y.times(x);
	    n >>= 1;
	    if (!n)
	      break;
	    x = x.times(x);
	  }
	  return isneg ? one.div(y) : y;
	};
	P.prec = function(sd, rm) {
	  if (sd !== ~~sd || sd < 1 || sd > MAX_DP) {
	    throw Error(INVALID + "precision");
	  }
	  return round(new this.constructor(this), sd, rm);
	};
	P.round = function(dp, rm) {
	  if (dp === UNDEFINED)
	    dp = 0;
	  else if (dp !== ~~dp || dp < -MAX_DP || dp > MAX_DP) {
	    throw Error(INVALID_DP);
	  }
	  return round(new this.constructor(this), dp + this.e + 1, rm);
	};
	P.sqrt = function() {
	  var r, c, t, x = this, Big2 = x.constructor, s = x.s, e = x.e, half = new Big2("0.5");
	  if (!x.c[0])
	    return new Big2(x);
	  if (s < 0) {
	    throw Error(NAME + "No square root");
	  }
	  s = Math.sqrt(x + "");
	  if (s === 0 || s === 1 / 0) {
	    c = x.c.join("");
	    if (!(c.length + e & 1))
	      c += "0";
	    s = Math.sqrt(c);
	    e = ((e + 1) / 2 | 0) - (e < 0 || e & 1);
	    r = new Big2((s == 1 / 0 ? "5e" : (s = s.toExponential()).slice(0, s.indexOf("e") + 1)) + e);
	  } else {
	    r = new Big2(s + "");
	  }
	  e = r.e + (Big2.DP += 4);
	  do {
	    t = r;
	    r = half.times(t.plus(x.div(t)));
	  } while (t.c.slice(0, e).join("") !== r.c.slice(0, e).join(""));
	  return round(r, (Big2.DP -= 4) + r.e + 1, Big2.RM);
	};
	P.times = P.mul = function(y) {
	  var c, x = this, Big2 = x.constructor, xc = x.c, yc = (y = new Big2(y)).c, a = xc.length, b = yc.length, i = x.e, j = y.e;
	  y.s = x.s == y.s ? 1 : -1;
	  if (!xc[0] || !yc[0]) {
	    y.c = [y.e = 0];
	    return y;
	  }
	  y.e = i + j;
	  if (a < b) {
	    c = xc;
	    xc = yc;
	    yc = c;
	    j = a;
	    a = b;
	    b = j;
	  }
	  for (c = new Array(j = a + b); j--; )
	    c[j] = 0;
	  for (i = b; i--; ) {
	    b = 0;
	    for (j = a + i; j > i; ) {
	      b = c[j] + yc[i] * xc[j - i - 1] + b;
	      c[j--] = b % 10;
	      b = b / 10 | 0;
	    }
	    c[j] = b;
	  }
	  if (b)
	    ++y.e;
	  else
	    c.shift();
	  for (i = c.length; !c[--i]; )
	    c.pop();
	  y.c = c;
	  return y;
	};
	P.toExponential = function(dp, rm) {
	  var x = this, n = x.c[0];
	  if (dp !== UNDEFINED) {
	    if (dp !== ~~dp || dp < 0 || dp > MAX_DP) {
	      throw Error(INVALID_DP);
	    }
	    x = round(new x.constructor(x), ++dp, rm);
	    for (; x.c.length < dp; )
	      x.c.push(0);
	  }
	  return stringify(x, true, !!n);
	};
	P.toFixed = function(dp, rm) {
	  var x = this, n = x.c[0];
	  if (dp !== UNDEFINED) {
	    if (dp !== ~~dp || dp < 0 || dp > MAX_DP) {
	      throw Error(INVALID_DP);
	    }
	    x = round(new x.constructor(x), dp + x.e + 1, rm);
	    for (dp = dp + x.e + 1; x.c.length < dp; )
	      x.c.push(0);
	  }
	  return stringify(x, false, !!n);
	};
	P.toJSON = P.toString = function() {
	  var x = this, Big2 = x.constructor;
	  return stringify(x, x.e <= Big2.NE || x.e >= Big2.PE, !!x.c[0]);
	};
	P.toNumber = function() {
	  var n = Number(stringify(this, true, true));
	  if (this.constructor.strict === true && !this.eq(n.toString())) {
	    throw Error(NAME + "Imprecise conversion");
	  }
	  return n;
	};
	P.toPrecision = function(sd, rm) {
	  var x = this, Big2 = x.constructor, n = x.c[0];
	  if (sd !== UNDEFINED) {
	    if (sd !== ~~sd || sd < 1 || sd > MAX_DP) {
	      throw Error(INVALID + "precision");
	    }
	    x = round(new Big2(x), sd, rm);
	    for (; x.c.length < sd; )
	      x.c.push(0);
	  }
	  return stringify(x, sd <= x.e || x.e <= Big2.NE || x.e >= Big2.PE, !!n);
	};
	P.valueOf = function() {
	  var x = this, Big2 = x.constructor;
	  if (Big2.strict === true) {
	    throw Error(NAME + "valueOf disallowed");
	  }
	  return stringify(x, x.e <= Big2.NE || x.e >= Big2.PE, true);
	};
	const COLOR_LIST = [
	  "#FF7C7C",
	  "#ADD4EF",
	  "#BFDAA7",
	  "#FCAC65",
	  "#C6C1D2",
	  "#7598E4",
	  "#CF6D6C",
	  "#4979CF",
	  "#E1934B",
	  "#829649",
	  "#7D70AC",
	  "#2559B7"
	];
	function numberWithCommas(x) {
	  if (x === null || typeof x === "undefined") {
	    return "--";
	  }
	  const parts = x.toString().split(".");
	  parts[0] = parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, ",");
	  return parts.join(".");
	}
	React__default["default"].createContext({});

	var reactIs$2 = {exports: {}};

	/** @license React v17.0.2
	 * react-is.production.min.js
	 *
	 * Copyright (c) Facebook, Inc. and its affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 */
	if("function"===typeof Symbol&&Symbol.for){var x$1=Symbol.for;x$1("react.element");x$1("react.portal");x$1("react.fragment");x$1("react.strict_mode");x$1("react.profiler");x$1("react.provider");x$1("react.context");x$1("react.forward_ref");x$1("react.suspense");x$1("react.suspense_list");x$1("react.memo");x$1("react.lazy");x$1("react.block");x$1("react.server.block");x$1("react.fundamental");x$1("react.debug_trace_mode");x$1("react.legacy_hidden");}

	var reactIs_development$1 = {};

	/** @license React v17.0.2
	 * react-is.development.js
	 *
	 * Copyright (c) Facebook, Inc. and its affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 */

	{
	  (function() {

	// ATTENTION
	// When adding new symbols to this file,
	// Please consider also adding to 'react-devtools-shared/src/backend/ReactSymbols'
	// The Symbol used to tag the ReactElement-like types. If there is no native Symbol
	// nor polyfill, then a plain number is used for performance.
	var REACT_ELEMENT_TYPE = 0xeac7;
	var REACT_PORTAL_TYPE = 0xeaca;
	var REACT_FRAGMENT_TYPE = 0xeacb;
	var REACT_STRICT_MODE_TYPE = 0xeacc;
	var REACT_PROFILER_TYPE = 0xead2;
	var REACT_PROVIDER_TYPE = 0xeacd;
	var REACT_CONTEXT_TYPE = 0xeace;
	var REACT_FORWARD_REF_TYPE = 0xead0;
	var REACT_SUSPENSE_TYPE = 0xead1;
	var REACT_SUSPENSE_LIST_TYPE = 0xead8;
	var REACT_MEMO_TYPE = 0xead3;
	var REACT_LAZY_TYPE = 0xead4;
	var REACT_BLOCK_TYPE = 0xead9;
	var REACT_SERVER_BLOCK_TYPE = 0xeada;
	var REACT_FUNDAMENTAL_TYPE = 0xead5;
	var REACT_DEBUG_TRACING_MODE_TYPE = 0xeae1;
	var REACT_LEGACY_HIDDEN_TYPE = 0xeae3;

	if (typeof Symbol === 'function' && Symbol.for) {
	  var symbolFor = Symbol.for;
	  REACT_ELEMENT_TYPE = symbolFor('react.element');
	  REACT_PORTAL_TYPE = symbolFor('react.portal');
	  REACT_FRAGMENT_TYPE = symbolFor('react.fragment');
	  REACT_STRICT_MODE_TYPE = symbolFor('react.strict_mode');
	  REACT_PROFILER_TYPE = symbolFor('react.profiler');
	  REACT_PROVIDER_TYPE = symbolFor('react.provider');
	  REACT_CONTEXT_TYPE = symbolFor('react.context');
	  REACT_FORWARD_REF_TYPE = symbolFor('react.forward_ref');
	  REACT_SUSPENSE_TYPE = symbolFor('react.suspense');
	  REACT_SUSPENSE_LIST_TYPE = symbolFor('react.suspense_list');
	  REACT_MEMO_TYPE = symbolFor('react.memo');
	  REACT_LAZY_TYPE = symbolFor('react.lazy');
	  REACT_BLOCK_TYPE = symbolFor('react.block');
	  REACT_SERVER_BLOCK_TYPE = symbolFor('react.server.block');
	  REACT_FUNDAMENTAL_TYPE = symbolFor('react.fundamental');
	  symbolFor('react.scope');
	  symbolFor('react.opaque.id');
	  REACT_DEBUG_TRACING_MODE_TYPE = symbolFor('react.debug_trace_mode');
	  symbolFor('react.offscreen');
	  REACT_LEGACY_HIDDEN_TYPE = symbolFor('react.legacy_hidden');
	}

	// Filter certain DOM attributes (e.g. src, href) if their values are empty strings.

	var enableScopeAPI = false; // Experimental Create Event Handle API.

	function isValidElementType(type) {
	  if (typeof type === 'string' || typeof type === 'function') {
	    return true;
	  } // Note: typeof might be other than 'symbol' or 'number' (e.g. if it's a polyfill).


	  if (type === REACT_FRAGMENT_TYPE || type === REACT_PROFILER_TYPE || type === REACT_DEBUG_TRACING_MODE_TYPE || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || type === REACT_SUSPENSE_LIST_TYPE || type === REACT_LEGACY_HIDDEN_TYPE || enableScopeAPI ) {
	    return true;
	  }

	  if (typeof type === 'object' && type !== null) {
	    if (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE || type.$$typeof === REACT_FUNDAMENTAL_TYPE || type.$$typeof === REACT_BLOCK_TYPE || type[0] === REACT_SERVER_BLOCK_TYPE) {
	      return true;
	    }
	  }

	  return false;
	}

	function typeOf(object) {
	  if (typeof object === 'object' && object !== null) {
	    var $$typeof = object.$$typeof;

	    switch ($$typeof) {
	      case REACT_ELEMENT_TYPE:
	        var type = object.type;

	        switch (type) {
	          case REACT_FRAGMENT_TYPE:
	          case REACT_PROFILER_TYPE:
	          case REACT_STRICT_MODE_TYPE:
	          case REACT_SUSPENSE_TYPE:
	          case REACT_SUSPENSE_LIST_TYPE:
	            return type;

	          default:
	            var $$typeofType = type && type.$$typeof;

	            switch ($$typeofType) {
	              case REACT_CONTEXT_TYPE:
	              case REACT_FORWARD_REF_TYPE:
	              case REACT_LAZY_TYPE:
	              case REACT_MEMO_TYPE:
	              case REACT_PROVIDER_TYPE:
	                return $$typeofType;

	              default:
	                return $$typeof;
	            }

	        }

	      case REACT_PORTAL_TYPE:
	        return $$typeof;
	    }
	  }

	  return undefined;
	}
	var ContextConsumer = REACT_CONTEXT_TYPE;
	var ContextProvider = REACT_PROVIDER_TYPE;
	var Element = REACT_ELEMENT_TYPE;
	var ForwardRef = REACT_FORWARD_REF_TYPE;
	var Fragment = REACT_FRAGMENT_TYPE;
	var Lazy = REACT_LAZY_TYPE;
	var Memo = REACT_MEMO_TYPE;
	var Portal = REACT_PORTAL_TYPE;
	var Profiler = REACT_PROFILER_TYPE;
	var StrictMode = REACT_STRICT_MODE_TYPE;
	var Suspense = REACT_SUSPENSE_TYPE;
	var hasWarnedAboutDeprecatedIsAsyncMode = false;
	var hasWarnedAboutDeprecatedIsConcurrentMode = false; // AsyncMode should be deprecated

	function isAsyncMode(object) {
	  {
	    if (!hasWarnedAboutDeprecatedIsAsyncMode) {
	      hasWarnedAboutDeprecatedIsAsyncMode = true; // Using console['warn'] to evade Babel and ESLint

	      console['warn']('The ReactIs.isAsyncMode() alias has been deprecated, ' + 'and will be removed in React 18+.');
	    }
	  }

	  return false;
	}
	function isConcurrentMode(object) {
	  {
	    if (!hasWarnedAboutDeprecatedIsConcurrentMode) {
	      hasWarnedAboutDeprecatedIsConcurrentMode = true; // Using console['warn'] to evade Babel and ESLint

	      console['warn']('The ReactIs.isConcurrentMode() alias has been deprecated, ' + 'and will be removed in React 18+.');
	    }
	  }

	  return false;
	}
	function isContextConsumer(object) {
	  return typeOf(object) === REACT_CONTEXT_TYPE;
	}
	function isContextProvider(object) {
	  return typeOf(object) === REACT_PROVIDER_TYPE;
	}
	function isElement(object) {
	  return typeof object === 'object' && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
	}
	function isForwardRef(object) {
	  return typeOf(object) === REACT_FORWARD_REF_TYPE;
	}
	function isFragment(object) {
	  return typeOf(object) === REACT_FRAGMENT_TYPE;
	}
	function isLazy(object) {
	  return typeOf(object) === REACT_LAZY_TYPE;
	}
	function isMemo(object) {
	  return typeOf(object) === REACT_MEMO_TYPE;
	}
	function isPortal(object) {
	  return typeOf(object) === REACT_PORTAL_TYPE;
	}
	function isProfiler(object) {
	  return typeOf(object) === REACT_PROFILER_TYPE;
	}
	function isStrictMode(object) {
	  return typeOf(object) === REACT_STRICT_MODE_TYPE;
	}
	function isSuspense(object) {
	  return typeOf(object) === REACT_SUSPENSE_TYPE;
	}

	reactIs_development$1.ContextConsumer = ContextConsumer;
	reactIs_development$1.ContextProvider = ContextProvider;
	reactIs_development$1.Element = Element;
	reactIs_development$1.ForwardRef = ForwardRef;
	reactIs_development$1.Fragment = Fragment;
	reactIs_development$1.Lazy = Lazy;
	reactIs_development$1.Memo = Memo;
	reactIs_development$1.Portal = Portal;
	reactIs_development$1.Profiler = Profiler;
	reactIs_development$1.StrictMode = StrictMode;
	reactIs_development$1.Suspense = Suspense;
	reactIs_development$1.isAsyncMode = isAsyncMode;
	reactIs_development$1.isConcurrentMode = isConcurrentMode;
	reactIs_development$1.isContextConsumer = isContextConsumer;
	reactIs_development$1.isContextProvider = isContextProvider;
	reactIs_development$1.isElement = isElement;
	reactIs_development$1.isForwardRef = isForwardRef;
	reactIs_development$1.isFragment = isFragment;
	reactIs_development$1.isLazy = isLazy;
	reactIs_development$1.isMemo = isMemo;
	reactIs_development$1.isPortal = isPortal;
	reactIs_development$1.isProfiler = isProfiler;
	reactIs_development$1.isStrictMode = isStrictMode;
	reactIs_development$1.isSuspense = isSuspense;
	reactIs_development$1.isValidElementType = isValidElementType;
	reactIs_development$1.typeOf = typeOf;
	  })();
	}

	{
	  reactIs$2.exports = reactIs_development$1;
	}

	function stylis_min (W) {
	  function M(d, c, e, h, a) {
	    for (var m = 0, b = 0, v = 0, n = 0, q, g, x = 0, K = 0, k, u = k = q = 0, l = 0, r = 0, I = 0, t = 0, B = e.length, J = B - 1, y, f = '', p = '', F = '', G = '', C; l < B;) {
	      g = e.charCodeAt(l);
	      l === J && 0 !== b + n + v + m && (0 !== b && (g = 47 === b ? 10 : 47), n = v = m = 0, B++, J++);

	      if (0 === b + n + v + m) {
	        if (l === J && (0 < r && (f = f.replace(N, '')), 0 < f.trim().length)) {
	          switch (g) {
	            case 32:
	            case 9:
	            case 59:
	            case 13:
	            case 10:
	              break;

	            default:
	              f += e.charAt(l);
	          }

	          g = 59;
	        }

	        switch (g) {
	          case 123:
	            f = f.trim();
	            q = f.charCodeAt(0);
	            k = 1;

	            for (t = ++l; l < B;) {
	              switch (g = e.charCodeAt(l)) {
	                case 123:
	                  k++;
	                  break;

	                case 125:
	                  k--;
	                  break;

	                case 47:
	                  switch (g = e.charCodeAt(l + 1)) {
	                    case 42:
	                    case 47:
	                      a: {
	                        for (u = l + 1; u < J; ++u) {
	                          switch (e.charCodeAt(u)) {
	                            case 47:
	                              if (42 === g && 42 === e.charCodeAt(u - 1) && l + 2 !== u) {
	                                l = u + 1;
	                                break a;
	                              }

	                              break;

	                            case 10:
	                              if (47 === g) {
	                                l = u + 1;
	                                break a;
	                              }

	                          }
	                        }

	                        l = u;
	                      }

	                  }

	                  break;

	                case 91:
	                  g++;

	                case 40:
	                  g++;

	                case 34:
	                case 39:
	                  for (; l++ < J && e.charCodeAt(l) !== g;) {
	                  }

	              }

	              if (0 === k) break;
	              l++;
	            }

	            k = e.substring(t, l);
	            0 === q && (q = (f = f.replace(ca, '').trim()).charCodeAt(0));

	            switch (q) {
	              case 64:
	                0 < r && (f = f.replace(N, ''));
	                g = f.charCodeAt(1);

	                switch (g) {
	                  case 100:
	                  case 109:
	                  case 115:
	                  case 45:
	                    r = c;
	                    break;

	                  default:
	                    r = O;
	                }

	                k = M(c, r, k, g, a + 1);
	                t = k.length;
	                0 < A && (r = X(O, f, I), C = H(3, k, r, c, D, z, t, g, a, h), f = r.join(''), void 0 !== C && 0 === (t = (k = C.trim()).length) && (g = 0, k = ''));
	                if (0 < t) switch (g) {
	                  case 115:
	                    f = f.replace(da, ea);

	                  case 100:
	                  case 109:
	                  case 45:
	                    k = f + '{' + k + '}';
	                    break;

	                  case 107:
	                    f = f.replace(fa, '$1 $2');
	                    k = f + '{' + k + '}';
	                    k = 1 === w || 2 === w && L('@' + k, 3) ? '@-webkit-' + k + '@' + k : '@' + k;
	                    break;

	                  default:
	                    k = f + k, 112 === h && (k = (p += k, ''));
	                } else k = '';
	                break;

	              default:
	                k = M(c, X(c, f, I), k, h, a + 1);
	            }

	            F += k;
	            k = I = r = u = q = 0;
	            f = '';
	            g = e.charCodeAt(++l);
	            break;

	          case 125:
	          case 59:
	            f = (0 < r ? f.replace(N, '') : f).trim();
	            if (1 < (t = f.length)) switch (0 === u && (q = f.charCodeAt(0), 45 === q || 96 < q && 123 > q) && (t = (f = f.replace(' ', ':')).length), 0 < A && void 0 !== (C = H(1, f, c, d, D, z, p.length, h, a, h)) && 0 === (t = (f = C.trim()).length) && (f = '\x00\x00'), q = f.charCodeAt(0), g = f.charCodeAt(1), q) {
	              case 0:
	                break;

	              case 64:
	                if (105 === g || 99 === g) {
	                  G += f + e.charAt(l);
	                  break;
	                }

	              default:
	                58 !== f.charCodeAt(t - 1) && (p += P(f, q, g, f.charCodeAt(2)));
	            }
	            I = r = u = q = 0;
	            f = '';
	            g = e.charCodeAt(++l);
	        }
	      }

	      switch (g) {
	        case 13:
	        case 10:
	          47 === b ? b = 0 : 0 === 1 + q && 107 !== h && 0 < f.length && (r = 1, f += '\x00');
	          0 < A * Y && H(0, f, c, d, D, z, p.length, h, a, h);
	          z = 1;
	          D++;
	          break;

	        case 59:
	        case 125:
	          if (0 === b + n + v + m) {
	            z++;
	            break;
	          }

	        default:
	          z++;
	          y = e.charAt(l);

	          switch (g) {
	            case 9:
	            case 32:
	              if (0 === n + m + b) switch (x) {
	                case 44:
	                case 58:
	                case 9:
	                case 32:
	                  y = '';
	                  break;

	                default:
	                  32 !== g && (y = ' ');
	              }
	              break;

	            case 0:
	              y = '\\0';
	              break;

	            case 12:
	              y = '\\f';
	              break;

	            case 11:
	              y = '\\v';
	              break;

	            case 38:
	              0 === n + b + m && (r = I = 1, y = '\f' + y);
	              break;

	            case 108:
	              if (0 === n + b + m + E && 0 < u) switch (l - u) {
	                case 2:
	                  112 === x && 58 === e.charCodeAt(l - 3) && (E = x);

	                case 8:
	                  111 === K && (E = K);
	              }
	              break;

	            case 58:
	              0 === n + b + m && (u = l);
	              break;

	            case 44:
	              0 === b + v + n + m && (r = 1, y += '\r');
	              break;

	            case 34:
	            case 39:
	              0 === b && (n = n === g ? 0 : 0 === n ? g : n);
	              break;

	            case 91:
	              0 === n + b + v && m++;
	              break;

	            case 93:
	              0 === n + b + v && m--;
	              break;

	            case 41:
	              0 === n + b + m && v--;
	              break;

	            case 40:
	              if (0 === n + b + m) {
	                if (0 === q) switch (2 * x + 3 * K) {
	                  case 533:
	                    break;

	                  default:
	                    q = 1;
	                }
	                v++;
	              }

	              break;

	            case 64:
	              0 === b + v + n + m + u + k && (k = 1);
	              break;

	            case 42:
	            case 47:
	              if (!(0 < n + m + v)) switch (b) {
	                case 0:
	                  switch (2 * g + 3 * e.charCodeAt(l + 1)) {
	                    case 235:
	                      b = 47;
	                      break;

	                    case 220:
	                      t = l, b = 42;
	                  }

	                  break;

	                case 42:
	                  47 === g && 42 === x && t + 2 !== l && (33 === e.charCodeAt(t + 2) && (p += e.substring(t, l + 1)), y = '', b = 0);
	              }
	          }

	          0 === b && (f += y);
	      }

	      K = x;
	      x = g;
	      l++;
	    }

	    t = p.length;

	    if (0 < t) {
	      r = c;
	      if (0 < A && (C = H(2, p, r, d, D, z, t, h, a, h), void 0 !== C && 0 === (p = C).length)) return G + p + F;
	      p = r.join(',') + '{' + p + '}';

	      if (0 !== w * E) {
	        2 !== w || L(p, 2) || (E = 0);

	        switch (E) {
	          case 111:
	            p = p.replace(ha, ':-moz-$1') + p;
	            break;

	          case 112:
	            p = p.replace(Q, '::-webkit-input-$1') + p.replace(Q, '::-moz-$1') + p.replace(Q, ':-ms-input-$1') + p;
	        }

	        E = 0;
	      }
	    }

	    return G + p + F;
	  }

	  function X(d, c, e) {
	    var h = c.trim().split(ia);
	    c = h;
	    var a = h.length,
	        m = d.length;

	    switch (m) {
	      case 0:
	      case 1:
	        var b = 0;

	        for (d = 0 === m ? '' : d[0] + ' '; b < a; ++b) {
	          c[b] = Z(d, c[b], e).trim();
	        }

	        break;

	      default:
	        var v = b = 0;

	        for (c = []; b < a; ++b) {
	          for (var n = 0; n < m; ++n) {
	            c[v++] = Z(d[n] + ' ', h[b], e).trim();
	          }
	        }

	    }

	    return c;
	  }

	  function Z(d, c, e) {
	    var h = c.charCodeAt(0);
	    33 > h && (h = (c = c.trim()).charCodeAt(0));

	    switch (h) {
	      case 38:
	        return c.replace(F, '$1' + d.trim());

	      case 58:
	        return d.trim() + c.replace(F, '$1' + d.trim());

	      default:
	        if (0 < 1 * e && 0 < c.indexOf('\f')) return c.replace(F, (58 === d.charCodeAt(0) ? '' : '$1') + d.trim());
	    }

	    return d + c;
	  }

	  function P(d, c, e, h) {
	    var a = d + ';',
	        m = 2 * c + 3 * e + 4 * h;

	    if (944 === m) {
	      d = a.indexOf(':', 9) + 1;
	      var b = a.substring(d, a.length - 1).trim();
	      b = a.substring(0, d).trim() + b + ';';
	      return 1 === w || 2 === w && L(b, 1) ? '-webkit-' + b + b : b;
	    }

	    if (0 === w || 2 === w && !L(a, 1)) return a;

	    switch (m) {
	      case 1015:
	        return 97 === a.charCodeAt(10) ? '-webkit-' + a + a : a;

	      case 951:
	        return 116 === a.charCodeAt(3) ? '-webkit-' + a + a : a;

	      case 963:
	        return 110 === a.charCodeAt(5) ? '-webkit-' + a + a : a;

	      case 1009:
	        if (100 !== a.charCodeAt(4)) break;

	      case 969:
	      case 942:
	        return '-webkit-' + a + a;

	      case 978:
	        return '-webkit-' + a + '-moz-' + a + a;

	      case 1019:
	      case 983:
	        return '-webkit-' + a + '-moz-' + a + '-ms-' + a + a;

	      case 883:
	        if (45 === a.charCodeAt(8)) return '-webkit-' + a + a;
	        if (0 < a.indexOf('image-set(', 11)) return a.replace(ja, '$1-webkit-$2') + a;
	        break;

	      case 932:
	        if (45 === a.charCodeAt(4)) switch (a.charCodeAt(5)) {
	          case 103:
	            return '-webkit-box-' + a.replace('-grow', '') + '-webkit-' + a + '-ms-' + a.replace('grow', 'positive') + a;

	          case 115:
	            return '-webkit-' + a + '-ms-' + a.replace('shrink', 'negative') + a;

	          case 98:
	            return '-webkit-' + a + '-ms-' + a.replace('basis', 'preferred-size') + a;
	        }
	        return '-webkit-' + a + '-ms-' + a + a;

	      case 964:
	        return '-webkit-' + a + '-ms-flex-' + a + a;

	      case 1023:
	        if (99 !== a.charCodeAt(8)) break;
	        b = a.substring(a.indexOf(':', 15)).replace('flex-', '').replace('space-between', 'justify');
	        return '-webkit-box-pack' + b + '-webkit-' + a + '-ms-flex-pack' + b + a;

	      case 1005:
	        return ka.test(a) ? a.replace(aa, ':-webkit-') + a.replace(aa, ':-moz-') + a : a;

	      case 1e3:
	        b = a.substring(13).trim();
	        c = b.indexOf('-') + 1;

	        switch (b.charCodeAt(0) + b.charCodeAt(c)) {
	          case 226:
	            b = a.replace(G, 'tb');
	            break;

	          case 232:
	            b = a.replace(G, 'tb-rl');
	            break;

	          case 220:
	            b = a.replace(G, 'lr');
	            break;

	          default:
	            return a;
	        }

	        return '-webkit-' + a + '-ms-' + b + a;

	      case 1017:
	        if (-1 === a.indexOf('sticky', 9)) break;

	      case 975:
	        c = (a = d).length - 10;
	        b = (33 === a.charCodeAt(c) ? a.substring(0, c) : a).substring(d.indexOf(':', 7) + 1).trim();

	        switch (m = b.charCodeAt(0) + (b.charCodeAt(7) | 0)) {
	          case 203:
	            if (111 > b.charCodeAt(8)) break;

	          case 115:
	            a = a.replace(b, '-webkit-' + b) + ';' + a;
	            break;

	          case 207:
	          case 102:
	            a = a.replace(b, '-webkit-' + (102 < m ? 'inline-' : '') + 'box') + ';' + a.replace(b, '-webkit-' + b) + ';' + a.replace(b, '-ms-' + b + 'box') + ';' + a;
	        }

	        return a + ';';

	      case 938:
	        if (45 === a.charCodeAt(5)) switch (a.charCodeAt(6)) {
	          case 105:
	            return b = a.replace('-items', ''), '-webkit-' + a + '-webkit-box-' + b + '-ms-flex-' + b + a;

	          case 115:
	            return '-webkit-' + a + '-ms-flex-item-' + a.replace(ba, '') + a;

	          default:
	            return '-webkit-' + a + '-ms-flex-line-pack' + a.replace('align-content', '').replace(ba, '') + a;
	        }
	        break;

	      case 973:
	      case 989:
	        if (45 !== a.charCodeAt(3) || 122 === a.charCodeAt(4)) break;

	      case 931:
	      case 953:
	        if (!0 === la.test(d)) return 115 === (b = d.substring(d.indexOf(':') + 1)).charCodeAt(0) ? P(d.replace('stretch', 'fill-available'), c, e, h).replace(':fill-available', ':stretch') : a.replace(b, '-webkit-' + b) + a.replace(b, '-moz-' + b.replace('fill-', '')) + a;
	        break;

	      case 962:
	        if (a = '-webkit-' + a + (102 === a.charCodeAt(5) ? '-ms-' + a : '') + a, 211 === e + h && 105 === a.charCodeAt(13) && 0 < a.indexOf('transform', 10)) return a.substring(0, a.indexOf(';', 27) + 1).replace(ma, '$1-webkit-$2') + a;
	    }

	    return a;
	  }

	  function L(d, c) {
	    var e = d.indexOf(1 === c ? ':' : '{'),
	        h = d.substring(0, 3 !== c ? e : 10);
	    e = d.substring(e + 1, d.length - 1);
	    return R(2 !== c ? h : h.replace(na, '$1'), e, c);
	  }

	  function ea(d, c) {
	    var e = P(c, c.charCodeAt(0), c.charCodeAt(1), c.charCodeAt(2));
	    return e !== c + ';' ? e.replace(oa, ' or ($1)').substring(4) : '(' + c + ')';
	  }

	  function H(d, c, e, h, a, m, b, v, n, q) {
	    for (var g = 0, x = c, w; g < A; ++g) {
	      switch (w = S[g].call(B, d, x, e, h, a, m, b, v, n, q)) {
	        case void 0:
	        case !1:
	        case !0:
	        case null:
	          break;

	        default:
	          x = w;
	      }
	    }

	    if (x !== c) return x;
	  }

	  function T(d) {
	    switch (d) {
	      case void 0:
	      case null:
	        A = S.length = 0;
	        break;

	      default:
	        if ('function' === typeof d) S[A++] = d;else if ('object' === typeof d) for (var c = 0, e = d.length; c < e; ++c) {
	          T(d[c]);
	        } else Y = !!d | 0;
	    }

	    return T;
	  }

	  function U(d) {
	    d = d.prefix;
	    void 0 !== d && (R = null, d ? 'function' !== typeof d ? w = 1 : (w = 2, R = d) : w = 0);
	    return U;
	  }

	  function B(d, c) {
	    var e = d;
	    33 > e.charCodeAt(0) && (e = e.trim());
	    V = e;
	    e = [V];

	    if (0 < A) {
	      var h = H(-1, c, e, e, D, z, 0, 0, 0, 0);
	      void 0 !== h && 'string' === typeof h && (c = h);
	    }

	    var a = M(O, e, c, 0, 0);
	    0 < A && (h = H(-2, a, e, e, D, z, a.length, 0, 0, 0), void 0 !== h && (a = h));
	    V = '';
	    E = 0;
	    z = D = 1;
	    return a;
	  }

	  var ca = /^\0+/g,
	      N = /[\0\r\f]/g,
	      aa = /: */g,
	      ka = /zoo|gra/,
	      ma = /([,: ])(transform)/g,
	      ia = /,\r+?/g,
	      F = /([\t\r\n ])*\f?&/g,
	      fa = /@(k\w+)\s*(\S*)\s*/,
	      Q = /::(place)/g,
	      ha = /:(read-only)/g,
	      G = /[svh]\w+-[tblr]{2}/,
	      da = /\(\s*(.*)\s*\)/g,
	      oa = /([\s\S]*?);/g,
	      ba = /-self|flex-/g,
	      na = /[^]*?(:[rp][el]a[\w-]+)[^]*/,
	      la = /stretch|:\s*\w+\-(?:conte|avail)/,
	      ja = /([^-])(image-set\()/,
	      z = 1,
	      D = 1,
	      E = 0,
	      w = 1,
	      O = [],
	      S = [],
	      A = 0,
	      R = null,
	      Y = 0,
	      V = '';
	  B.use = T;
	  B.set = U;
	  void 0 !== W && U(W);
	  return B;
	}

	var unitlessKeys = {
	  animationIterationCount: 1,
	  borderImageOutset: 1,
	  borderImageSlice: 1,
	  borderImageWidth: 1,
	  boxFlex: 1,
	  boxFlexGroup: 1,
	  boxOrdinalGroup: 1,
	  columnCount: 1,
	  columns: 1,
	  flex: 1,
	  flexGrow: 1,
	  flexPositive: 1,
	  flexShrink: 1,
	  flexNegative: 1,
	  flexOrder: 1,
	  gridRow: 1,
	  gridRowEnd: 1,
	  gridRowSpan: 1,
	  gridRowStart: 1,
	  gridColumn: 1,
	  gridColumnEnd: 1,
	  gridColumnSpan: 1,
	  gridColumnStart: 1,
	  msGridRow: 1,
	  msGridRowSpan: 1,
	  msGridColumn: 1,
	  msGridColumnSpan: 1,
	  fontWeight: 1,
	  lineHeight: 1,
	  opacity: 1,
	  order: 1,
	  orphans: 1,
	  tabSize: 1,
	  widows: 1,
	  zIndex: 1,
	  zoom: 1,
	  WebkitLineClamp: 1,
	  // SVG-related properties
	  fillOpacity: 1,
	  floodOpacity: 1,
	  stopOpacity: 1,
	  strokeDasharray: 1,
	  strokeDashoffset: 1,
	  strokeMiterlimit: 1,
	  strokeOpacity: 1,
	  strokeWidth: 1
	};

	function memoize(fn) {
	  var cache = {};
	  return function (arg) {
	    if (cache[arg] === undefined) cache[arg] = fn(arg);
	    return cache[arg];
	  };
	}

	var reactPropsRegex = /^((children|dangerouslySetInnerHTML|key|ref|autoFocus|defaultValue|defaultChecked|innerHTML|suppressContentEditableWarning|suppressHydrationWarning|valueLink|accept|acceptCharset|accessKey|action|allow|allowUserMedia|allowPaymentRequest|allowFullScreen|allowTransparency|alt|async|autoComplete|autoPlay|capture|cellPadding|cellSpacing|challenge|charSet|checked|cite|classID|className|cols|colSpan|content|contentEditable|contextMenu|controls|controlsList|coords|crossOrigin|data|dateTime|decoding|default|defer|dir|disabled|disablePictureInPicture|download|draggable|encType|form|formAction|formEncType|formMethod|formNoValidate|formTarget|frameBorder|headers|height|hidden|high|href|hrefLang|htmlFor|httpEquiv|id|inputMode|integrity|is|keyParams|keyType|kind|label|lang|list|loading|loop|low|marginHeight|marginWidth|max|maxLength|media|mediaGroup|method|min|minLength|multiple|muted|name|nonce|noValidate|open|optimum|pattern|placeholder|playsInline|poster|preload|profile|radioGroup|readOnly|referrerPolicy|rel|required|reversed|role|rows|rowSpan|sandbox|scope|scoped|scrolling|seamless|selected|shape|size|sizes|slot|span|spellCheck|src|srcDoc|srcLang|srcSet|start|step|style|summary|tabIndex|target|title|type|useMap|value|width|wmode|wrap|about|datatype|inlist|prefix|property|resource|typeof|vocab|autoCapitalize|autoCorrect|autoSave|color|inert|itemProp|itemScope|itemType|itemID|itemRef|on|results|security|unselectable|accentHeight|accumulate|additive|alignmentBaseline|allowReorder|alphabetic|amplitude|arabicForm|ascent|attributeName|attributeType|autoReverse|azimuth|baseFrequency|baselineShift|baseProfile|bbox|begin|bias|by|calcMode|capHeight|clip|clipPathUnits|clipPath|clipRule|colorInterpolation|colorInterpolationFilters|colorProfile|colorRendering|contentScriptType|contentStyleType|cursor|cx|cy|d|decelerate|descent|diffuseConstant|direction|display|divisor|dominantBaseline|dur|dx|dy|edgeMode|elevation|enableBackground|end|exponent|externalResourcesRequired|fill|fillOpacity|fillRule|filter|filterRes|filterUnits|floodColor|floodOpacity|focusable|fontFamily|fontSize|fontSizeAdjust|fontStretch|fontStyle|fontVariant|fontWeight|format|from|fr|fx|fy|g1|g2|glyphName|glyphOrientationHorizontal|glyphOrientationVertical|glyphRef|gradientTransform|gradientUnits|hanging|horizAdvX|horizOriginX|ideographic|imageRendering|in|in2|intercept|k|k1|k2|k3|k4|kernelMatrix|kernelUnitLength|kerning|keyPoints|keySplines|keyTimes|lengthAdjust|letterSpacing|lightingColor|limitingConeAngle|local|markerEnd|markerMid|markerStart|markerHeight|markerUnits|markerWidth|mask|maskContentUnits|maskUnits|mathematical|mode|numOctaves|offset|opacity|operator|order|orient|orientation|origin|overflow|overlinePosition|overlineThickness|panose1|paintOrder|pathLength|patternContentUnits|patternTransform|patternUnits|pointerEvents|points|pointsAtX|pointsAtY|pointsAtZ|preserveAlpha|preserveAspectRatio|primitiveUnits|r|radius|refX|refY|renderingIntent|repeatCount|repeatDur|requiredExtensions|requiredFeatures|restart|result|rotate|rx|ry|scale|seed|shapeRendering|slope|spacing|specularConstant|specularExponent|speed|spreadMethod|startOffset|stdDeviation|stemh|stemv|stitchTiles|stopColor|stopOpacity|strikethroughPosition|strikethroughThickness|string|stroke|strokeDasharray|strokeDashoffset|strokeLinecap|strokeLinejoin|strokeMiterlimit|strokeOpacity|strokeWidth|surfaceScale|systemLanguage|tableValues|targetX|targetY|textAnchor|textDecoration|textRendering|textLength|to|transform|u1|u2|underlinePosition|underlineThickness|unicode|unicodeBidi|unicodeRange|unitsPerEm|vAlphabetic|vHanging|vIdeographic|vMathematical|values|vectorEffect|version|vertAdvY|vertOriginX|vertOriginY|viewBox|viewTarget|visibility|widths|wordSpacing|writingMode|x|xHeight|x1|x2|xChannelSelector|xlinkActuate|xlinkArcrole|xlinkHref|xlinkRole|xlinkShow|xlinkTitle|xlinkType|xmlBase|xmlns|xmlnsXlink|xmlLang|xmlSpace|y|y1|y2|yChannelSelector|z|zoomAndPan|for|class|autofocus)|(([Dd][Aa][Tt][Aa]|[Aa][Rr][Ii][Aa]|x)-.*))$/; // https://esbench.com/bench/5bfee68a4cd7e6009ef61d23

	var index = memoize(function (prop) {
	  return reactPropsRegex.test(prop) || prop.charCodeAt(0) === 111
	  /* o */
	  && prop.charCodeAt(1) === 110
	  /* n */
	  && prop.charCodeAt(2) < 91;
	}
	/* Z+1 */
	);

	var reactIs$1 = {exports: {}};

	var reactIs_development = {};

	/** @license React v16.13.1
	 * react-is.development.js
	 *
	 * Copyright (c) Facebook, Inc. and its affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 */



	{
	  (function() {

	// The Symbol used to tag the ReactElement-like types. If there is no native Symbol
	// nor polyfill, then a plain number is used for performance.
	var hasSymbol = typeof Symbol === 'function' && Symbol.for;
	var REACT_ELEMENT_TYPE = hasSymbol ? Symbol.for('react.element') : 0xeac7;
	var REACT_PORTAL_TYPE = hasSymbol ? Symbol.for('react.portal') : 0xeaca;
	var REACT_FRAGMENT_TYPE = hasSymbol ? Symbol.for('react.fragment') : 0xeacb;
	var REACT_STRICT_MODE_TYPE = hasSymbol ? Symbol.for('react.strict_mode') : 0xeacc;
	var REACT_PROFILER_TYPE = hasSymbol ? Symbol.for('react.profiler') : 0xead2;
	var REACT_PROVIDER_TYPE = hasSymbol ? Symbol.for('react.provider') : 0xeacd;
	var REACT_CONTEXT_TYPE = hasSymbol ? Symbol.for('react.context') : 0xeace; // TODO: We don't use AsyncMode or ConcurrentMode anymore. They were temporary
	// (unstable) APIs that have been removed. Can we remove the symbols?

	var REACT_ASYNC_MODE_TYPE = hasSymbol ? Symbol.for('react.async_mode') : 0xeacf;
	var REACT_CONCURRENT_MODE_TYPE = hasSymbol ? Symbol.for('react.concurrent_mode') : 0xeacf;
	var REACT_FORWARD_REF_TYPE = hasSymbol ? Symbol.for('react.forward_ref') : 0xead0;
	var REACT_SUSPENSE_TYPE = hasSymbol ? Symbol.for('react.suspense') : 0xead1;
	var REACT_SUSPENSE_LIST_TYPE = hasSymbol ? Symbol.for('react.suspense_list') : 0xead8;
	var REACT_MEMO_TYPE = hasSymbol ? Symbol.for('react.memo') : 0xead3;
	var REACT_LAZY_TYPE = hasSymbol ? Symbol.for('react.lazy') : 0xead4;
	var REACT_BLOCK_TYPE = hasSymbol ? Symbol.for('react.block') : 0xead9;
	var REACT_FUNDAMENTAL_TYPE = hasSymbol ? Symbol.for('react.fundamental') : 0xead5;
	var REACT_RESPONDER_TYPE = hasSymbol ? Symbol.for('react.responder') : 0xead6;
	var REACT_SCOPE_TYPE = hasSymbol ? Symbol.for('react.scope') : 0xead7;

	function isValidElementType(type) {
	  return typeof type === 'string' || typeof type === 'function' || // Note: its typeof might be other than 'symbol' or 'number' if it's a polyfill.
	  type === REACT_FRAGMENT_TYPE || type === REACT_CONCURRENT_MODE_TYPE || type === REACT_PROFILER_TYPE || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || type === REACT_SUSPENSE_LIST_TYPE || typeof type === 'object' && type !== null && (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE || type.$$typeof === REACT_FUNDAMENTAL_TYPE || type.$$typeof === REACT_RESPONDER_TYPE || type.$$typeof === REACT_SCOPE_TYPE || type.$$typeof === REACT_BLOCK_TYPE);
	}

	function typeOf(object) {
	  if (typeof object === 'object' && object !== null) {
	    var $$typeof = object.$$typeof;

	    switch ($$typeof) {
	      case REACT_ELEMENT_TYPE:
	        var type = object.type;

	        switch (type) {
	          case REACT_ASYNC_MODE_TYPE:
	          case REACT_CONCURRENT_MODE_TYPE:
	          case REACT_FRAGMENT_TYPE:
	          case REACT_PROFILER_TYPE:
	          case REACT_STRICT_MODE_TYPE:
	          case REACT_SUSPENSE_TYPE:
	            return type;

	          default:
	            var $$typeofType = type && type.$$typeof;

	            switch ($$typeofType) {
	              case REACT_CONTEXT_TYPE:
	              case REACT_FORWARD_REF_TYPE:
	              case REACT_LAZY_TYPE:
	              case REACT_MEMO_TYPE:
	              case REACT_PROVIDER_TYPE:
	                return $$typeofType;

	              default:
	                return $$typeof;
	            }

	        }

	      case REACT_PORTAL_TYPE:
	        return $$typeof;
	    }
	  }

	  return undefined;
	} // AsyncMode is deprecated along with isAsyncMode

	var AsyncMode = REACT_ASYNC_MODE_TYPE;
	var ConcurrentMode = REACT_CONCURRENT_MODE_TYPE;
	var ContextConsumer = REACT_CONTEXT_TYPE;
	var ContextProvider = REACT_PROVIDER_TYPE;
	var Element = REACT_ELEMENT_TYPE;
	var ForwardRef = REACT_FORWARD_REF_TYPE;
	var Fragment = REACT_FRAGMENT_TYPE;
	var Lazy = REACT_LAZY_TYPE;
	var Memo = REACT_MEMO_TYPE;
	var Portal = REACT_PORTAL_TYPE;
	var Profiler = REACT_PROFILER_TYPE;
	var StrictMode = REACT_STRICT_MODE_TYPE;
	var Suspense = REACT_SUSPENSE_TYPE;
	var hasWarnedAboutDeprecatedIsAsyncMode = false; // AsyncMode should be deprecated

	function isAsyncMode(object) {
	  {
	    if (!hasWarnedAboutDeprecatedIsAsyncMode) {
	      hasWarnedAboutDeprecatedIsAsyncMode = true; // Using console['warn'] to evade Babel and ESLint

	      console['warn']('The ReactIs.isAsyncMode() alias has been deprecated, ' + 'and will be removed in React 17+. Update your code to use ' + 'ReactIs.isConcurrentMode() instead. It has the exact same API.');
	    }
	  }

	  return isConcurrentMode(object) || typeOf(object) === REACT_ASYNC_MODE_TYPE;
	}
	function isConcurrentMode(object) {
	  return typeOf(object) === REACT_CONCURRENT_MODE_TYPE;
	}
	function isContextConsumer(object) {
	  return typeOf(object) === REACT_CONTEXT_TYPE;
	}
	function isContextProvider(object) {
	  return typeOf(object) === REACT_PROVIDER_TYPE;
	}
	function isElement(object) {
	  return typeof object === 'object' && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
	}
	function isForwardRef(object) {
	  return typeOf(object) === REACT_FORWARD_REF_TYPE;
	}
	function isFragment(object) {
	  return typeOf(object) === REACT_FRAGMENT_TYPE;
	}
	function isLazy(object) {
	  return typeOf(object) === REACT_LAZY_TYPE;
	}
	function isMemo(object) {
	  return typeOf(object) === REACT_MEMO_TYPE;
	}
	function isPortal(object) {
	  return typeOf(object) === REACT_PORTAL_TYPE;
	}
	function isProfiler(object) {
	  return typeOf(object) === REACT_PROFILER_TYPE;
	}
	function isStrictMode(object) {
	  return typeOf(object) === REACT_STRICT_MODE_TYPE;
	}
	function isSuspense(object) {
	  return typeOf(object) === REACT_SUSPENSE_TYPE;
	}

	reactIs_development.AsyncMode = AsyncMode;
	reactIs_development.ConcurrentMode = ConcurrentMode;
	reactIs_development.ContextConsumer = ContextConsumer;
	reactIs_development.ContextProvider = ContextProvider;
	reactIs_development.Element = Element;
	reactIs_development.ForwardRef = ForwardRef;
	reactIs_development.Fragment = Fragment;
	reactIs_development.Lazy = Lazy;
	reactIs_development.Memo = Memo;
	reactIs_development.Portal = Portal;
	reactIs_development.Profiler = Profiler;
	reactIs_development.StrictMode = StrictMode;
	reactIs_development.Suspense = Suspense;
	reactIs_development.isAsyncMode = isAsyncMode;
	reactIs_development.isConcurrentMode = isConcurrentMode;
	reactIs_development.isContextConsumer = isContextConsumer;
	reactIs_development.isContextProvider = isContextProvider;
	reactIs_development.isElement = isElement;
	reactIs_development.isForwardRef = isForwardRef;
	reactIs_development.isFragment = isFragment;
	reactIs_development.isLazy = isLazy;
	reactIs_development.isMemo = isMemo;
	reactIs_development.isPortal = isPortal;
	reactIs_development.isProfiler = isProfiler;
	reactIs_development.isStrictMode = isStrictMode;
	reactIs_development.isSuspense = isSuspense;
	reactIs_development.isValidElementType = isValidElementType;
	reactIs_development.typeOf = typeOf;
	  })();
	}

	{
	  reactIs$1.exports = reactIs_development;
	}

	var reactIs = reactIs$1.exports;

	/**
	 * Copyright 2015, Yahoo! Inc.
	 * Copyrights licensed under the New BSD License. See the accompanying LICENSE file for terms.
	 */
	var REACT_STATICS = {
	  childContextTypes: true,
	  contextType: true,
	  contextTypes: true,
	  defaultProps: true,
	  displayName: true,
	  getDefaultProps: true,
	  getDerivedStateFromError: true,
	  getDerivedStateFromProps: true,
	  mixins: true,
	  propTypes: true,
	  type: true
	};
	var KNOWN_STATICS = {
	  name: true,
	  length: true,
	  prototype: true,
	  caller: true,
	  callee: true,
	  arguments: true,
	  arity: true
	};
	var FORWARD_REF_STATICS = {
	  '$$typeof': true,
	  render: true,
	  defaultProps: true,
	  displayName: true,
	  propTypes: true
	};
	var MEMO_STATICS = {
	  '$$typeof': true,
	  compare: true,
	  defaultProps: true,
	  displayName: true,
	  propTypes: true,
	  type: true
	};
	var TYPE_STATICS = {};
	TYPE_STATICS[reactIs.ForwardRef] = FORWARD_REF_STATICS;
	TYPE_STATICS[reactIs.Memo] = MEMO_STATICS;

	function getStatics(component) {
	  // React v16.11 and below
	  if (reactIs.isMemo(component)) {
	    return MEMO_STATICS;
	  } // React v16.12 and above


	  return TYPE_STATICS[component['$$typeof']] || REACT_STATICS;
	}

	var defineProperty$1 = Object.defineProperty;
	var getOwnPropertyNames = Object.getOwnPropertyNames;
	var getOwnPropertySymbols = Object.getOwnPropertySymbols;
	var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
	var getPrototypeOf = Object.getPrototypeOf;
	var objectPrototype = Object.prototype;
	function hoistNonReactStatics(targetComponent, sourceComponent, blacklist) {
	  if (typeof sourceComponent !== 'string') {
	    // don't hoist over string (html) components
	    if (objectPrototype) {
	      var inheritedComponent = getPrototypeOf(sourceComponent);

	      if (inheritedComponent && inheritedComponent !== objectPrototype) {
	        hoistNonReactStatics(targetComponent, inheritedComponent, blacklist);
	      }
	    }

	    var keys = getOwnPropertyNames(sourceComponent);

	    if (getOwnPropertySymbols) {
	      keys = keys.concat(getOwnPropertySymbols(sourceComponent));
	    }

	    var targetStatics = getStatics(targetComponent);
	    var sourceStatics = getStatics(sourceComponent);

	    for (var i = 0; i < keys.length; ++i) {
	      var key = keys[i];

	      if (!KNOWN_STATICS[key] && !(blacklist && blacklist[key]) && !(sourceStatics && sourceStatics[key]) && !(targetStatics && targetStatics[key])) {
	        var descriptor = getOwnPropertyDescriptor(sourceComponent, key);

	        try {
	          // Avoid failures from read-only properties
	          defineProperty$1(targetComponent, key, descriptor);
	        } catch (e) {}
	      }
	    }
	  }

	  return targetComponent;
	}

	var hoistNonReactStatics_cjs = hoistNonReactStatics;

	function y(){return (y=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r]);}return e}).apply(this,arguments)}var v=function(e,t){for(var n=[e[0]],r=0,o=t.length;r<o;r+=1)n.push(t[r],e[r+1]);return n},g=function(t){return null!==t&&"object"==typeof t&&"[object Object]"===(t.toString?t.toString():Object.prototype.toString.call(t))&&!reactIs$2.exports.typeOf(t)},S=Object.freeze([]),w=Object.freeze({});function E(e){return "function"==typeof e}function b(e){return "string"==typeof e&&e||e.displayName||e.name||"Component"}function _(e){return e&&"string"==typeof e.styledComponentId}var N="undefined"!=typeof process&&(process.env.REACT_APP_SC_ATTR||process.env.SC_ATTR)||"data-styled",C="undefined"!=typeof window&&"HTMLElement"in window,I=Boolean("boolean"==typeof SC_DISABLE_SPEEDY?SC_DISABLE_SPEEDY:"undefined"!=typeof process&&void 0!==process.env.REACT_APP_SC_DISABLE_SPEEDY&&""!==process.env.REACT_APP_SC_DISABLE_SPEEDY?"false"!==process.env.REACT_APP_SC_DISABLE_SPEEDY&&process.env.REACT_APP_SC_DISABLE_SPEEDY:"undefined"!=typeof process&&void 0!==process.env.SC_DISABLE_SPEEDY&&""!==process.env.SC_DISABLE_SPEEDY?"false"!==process.env.SC_DISABLE_SPEEDY&&process.env.SC_DISABLE_SPEEDY:"production"!=="development"),O={1:"Cannot create styled-component for component: %s.\n\n",2:"Can't collect styles once you've consumed a `ServerStyleSheet`'s styles! `ServerStyleSheet` is a one off instance for each server-side render cycle.\n\n- Are you trying to reuse it across renders?\n- Are you accidentally calling collectStyles twice?\n\n",3:"Streaming SSR is only supported in a Node.js environment; Please do not try to call this method in the browser.\n\n",4:"The `StyleSheetManager` expects a valid target or sheet prop!\n\n- Does this error occur on the client and is your target falsy?\n- Does this error occur on the server and is the sheet falsy?\n\n",5:"The clone method cannot be used on the client!\n\n- Are you running in a client-like environment on the server?\n- Are you trying to run SSR on the client?\n\n",6:"Trying to insert a new style tag, but the given Node is unmounted!\n\n- Are you using a custom target that isn't mounted?\n- Does your document not have a valid head element?\n- Have you accidentally removed a style tag manually?\n\n",7:'ThemeProvider: Please return an object from your "theme" prop function, e.g.\n\n```js\ntheme={() => ({})}\n```\n\n',8:'ThemeProvider: Please make your "theme" prop an object.\n\n',9:"Missing document `<head>`\n\n",10:"Cannot find a StyleSheet instance. Usually this happens if there are multiple copies of styled-components loaded at once. Check out this issue for how to troubleshoot and fix the common cases where this situation can happen: https://github.com/styled-components/styled-components/issues/1941#issuecomment-417862021\n\n",11:"_This error was replaced with a dev-time warning, it will be deleted for v4 final._ [createGlobalStyle] received children which will not be rendered. Please use the component without passing children elements.\n\n",12:"It seems you are interpolating a keyframe declaration (%s) into an untagged string. This was supported in styled-components v3, but is not longer supported in v4 as keyframes are now injected on-demand. Please wrap your string in the css\\`\\` helper which ensures the styles are injected correctly. See https://www.styled-components.com/docs/api#css\n\n",13:"%s is not a styled component and cannot be referred to via component selector. See https://www.styled-components.com/docs/advanced#referring-to-other-components for more details.\n\n",14:'ThemeProvider: "theme" prop is required.\n\n',15:"A stylis plugin has been supplied that is not named. We need a name for each plugin to be able to prevent styling collisions between different stylis configurations within the same app. Before you pass your plugin to `<StyleSheetManager stylisPlugins={[]}>`, please make sure each plugin is uniquely-named, e.g.\n\n```js\nObject.defineProperty(importedPlugin, 'name', { value: 'some-unique-name' });\n```\n\n",16:"Reached the limit of how many styled components may be created at group %s.\nYou may only create up to 1,073,741,824 components. If you're creating components dynamically,\nas for instance in your render method then you may be running into this limitation.\n\n",17:"CSSStyleSheet could not be found on HTMLStyleElement.\nHas styled-components' style tag been unmounted or altered by another script?\n"};function R(){for(var e=arguments.length<=0?void 0:arguments[0],t=[],n=1,r=arguments.length;n<r;n+=1)t.push(n<0||arguments.length<=n?void 0:arguments[n]);return t.forEach((function(t){e=e.replace(/%[a-z]/,t);})),e}function D(e){for(var t=arguments.length,n=new Array(t>1?t-1:0),r=1;r<t;r++)n[r-1]=arguments[r];throw new Error(R.apply(void 0,[O[e]].concat(n)).trim())}var j=function(){function e(e){this.groupSizes=new Uint32Array(512),this.length=512,this.tag=e;}var t=e.prototype;return t.indexOfGroup=function(e){for(var t=0,n=0;n<e;n++)t+=this.groupSizes[n];return t},t.insertRules=function(e,t){if(e>=this.groupSizes.length){for(var n=this.groupSizes,r=n.length,o=r;e>=o;)(o<<=1)<0&&D(16,""+e);this.groupSizes=new Uint32Array(o),this.groupSizes.set(n),this.length=o;for(var s=r;s<o;s++)this.groupSizes[s]=0;}for(var i=this.indexOfGroup(e+1),a=0,c=t.length;a<c;a++)this.tag.insertRule(i,t[a])&&(this.groupSizes[e]++,i++);},t.clearGroup=function(e){if(e<this.length){var t=this.groupSizes[e],n=this.indexOfGroup(e),r=n+t;this.groupSizes[e]=0;for(var o=n;o<r;o++)this.tag.deleteRule(n);}},t.getGroup=function(e){var t="";if(e>=this.length||0===this.groupSizes[e])return t;for(var n=this.groupSizes[e],r=this.indexOfGroup(e),o=r+n,s=r;s<o;s++)t+=this.tag.getRule(s)+"/*!sc*/\n";return t},e}(),T=new Map,x=new Map,k=1,V=function(e){if(T.has(e))return T.get(e);for(;x.has(k);)k++;var t=k++;return ((0|t)<0||t>1<<30)&&D(16,""+t),T.set(e,t),x.set(t,e),t},z=function(e){return x.get(e)},B=function(e,t){t>=k&&(k=t+1),T.set(e,t),x.set(t,e);},M="style["+N+'][data-styled-version="5.3.3"]',G=new RegExp("^"+N+'\\.g(\\d+)\\[id="([\\w\\d-]+)"\\].*?"([^"]*)'),L=function(e,t,n){for(var r,o=n.split(","),s=0,i=o.length;s<i;s++)(r=o[s])&&e.registerName(t,r);},F=function(e,t){for(var n=(t.textContent||"").split("/*!sc*/\n"),r=[],o=0,s=n.length;o<s;o++){var i=n[o].trim();if(i){var a=i.match(G);if(a){var c=0|parseInt(a[1],10),u=a[2];0!==c&&(B(u,c),L(e,u,a[3]),e.getTag().insertRules(c,r)),r.length=0;}else r.push(i);}}},Y=function(){return "undefined"!=typeof window&&void 0!==window.__webpack_nonce__?window.__webpack_nonce__:null},q=function(e){var t=document.head,n=e||t,r=document.createElement("style"),o=function(e){for(var t=e.childNodes,n=t.length;n>=0;n--){var r=t[n];if(r&&1===r.nodeType&&r.hasAttribute(N))return r}}(n),s=void 0!==o?o.nextSibling:null;r.setAttribute(N,"active"),r.setAttribute("data-styled-version","5.3.3");var i=Y();return i&&r.setAttribute("nonce",i),n.insertBefore(r,s),r},H=function(){function e(e){var t=this.element=q(e);t.appendChild(document.createTextNode("")),this.sheet=function(e){if(e.sheet)return e.sheet;for(var t=document.styleSheets,n=0,r=t.length;n<r;n++){var o=t[n];if(o.ownerNode===e)return o}D(17);}(t),this.length=0;}var t=e.prototype;return t.insertRule=function(e,t){try{return this.sheet.insertRule(t,e),this.length++,!0}catch(e){return !1}},t.deleteRule=function(e){this.sheet.deleteRule(e),this.length--;},t.getRule=function(e){var t=this.sheet.cssRules[e];return void 0!==t&&"string"==typeof t.cssText?t.cssText:""},e}(),$=function(){function e(e){var t=this.element=q(e);this.nodes=t.childNodes,this.length=0;}var t=e.prototype;return t.insertRule=function(e,t){if(e<=this.length&&e>=0){var n=document.createTextNode(t),r=this.nodes[e];return this.element.insertBefore(n,r||null),this.length++,!0}return !1},t.deleteRule=function(e){this.element.removeChild(this.nodes[e]),this.length--;},t.getRule=function(e){return e<this.length?this.nodes[e].textContent:""},e}(),W=function(){function e(e){this.rules=[],this.length=0;}var t=e.prototype;return t.insertRule=function(e,t){return e<=this.length&&(this.rules.splice(e,0,t),this.length++,!0)},t.deleteRule=function(e){this.rules.splice(e,1),this.length--;},t.getRule=function(e){return e<this.length?this.rules[e]:""},e}(),U=C,J={isServer:!C,useCSSOMInjection:!I},X=function(){function e(e,t,n){void 0===e&&(e=w),void 0===t&&(t={}),this.options=y({},J,{},e),this.gs=t,this.names=new Map(n),this.server=!!e.isServer,!this.server&&C&&U&&(U=!1,function(e){for(var t=document.querySelectorAll(M),n=0,r=t.length;n<r;n++){var o=t[n];o&&"active"!==o.getAttribute(N)&&(F(e,o),o.parentNode&&o.parentNode.removeChild(o));}}(this));}e.registerId=function(e){return V(e)};var t=e.prototype;return t.reconstructWithOptions=function(t,n){return void 0===n&&(n=!0),new e(y({},this.options,{},t),this.gs,n&&this.names||void 0)},t.allocateGSInstance=function(e){return this.gs[e]=(this.gs[e]||0)+1},t.getTag=function(){return this.tag||(this.tag=(n=(t=this.options).isServer,r=t.useCSSOMInjection,o=t.target,e=n?new W(o):r?new H(o):new $(o),new j(e)));var e,t,n,r,o;},t.hasNameForId=function(e,t){return this.names.has(e)&&this.names.get(e).has(t)},t.registerName=function(e,t){if(V(e),this.names.has(e))this.names.get(e).add(t);else {var n=new Set;n.add(t),this.names.set(e,n);}},t.insertRules=function(e,t,n){this.registerName(e,t),this.getTag().insertRules(V(e),n);},t.clearNames=function(e){this.names.has(e)&&this.names.get(e).clear();},t.clearRules=function(e){this.getTag().clearGroup(V(e)),this.clearNames(e);},t.clearTag=function(){this.tag=void 0;},t.toString=function(){return function(e){for(var t=e.getTag(),n=t.length,r="",o=0;o<n;o++){var s=z(o);if(void 0!==s){var i=e.names.get(s),a=t.getGroup(o);if(i&&a&&i.size){var c=N+".g"+o+'[id="'+s+'"]',u="";void 0!==i&&i.forEach((function(e){e.length>0&&(u+=e+",");})),r+=""+a+c+'{content:"'+u+'"}/*!sc*/\n';}}}return r}(this)},e}(),Z=/(a)(d)/gi,K=function(e){return String.fromCharCode(e+(e>25?39:97))};function Q(e){var t,n="";for(t=Math.abs(e);t>52;t=t/52|0)n=K(t%52)+n;return (K(t%52)+n).replace(Z,"$1-$2")}var ee=function(e,t){for(var n=t.length;n;)e=33*e^t.charCodeAt(--n);return e},te=function(e){return ee(5381,e)};var re=te("5.3.3"),oe=function(){function e(e,t,n){this.rules=e,this.staticRulesId="",this.isStatic="production"==="development",this.componentId=t,this.baseHash=ee(re,t),this.baseStyle=n,X.registerId(t);}return e.prototype.generateAndInjectStyles=function(e,t,n){var r=this.componentId,o=[];if(this.baseStyle&&o.push(this.baseStyle.generateAndInjectStyles(e,t,n)),this.isStatic&&!n.hash)if(this.staticRulesId&&t.hasNameForId(r,this.staticRulesId))o.push(this.staticRulesId);else {var s=_e(this.rules,e,t,n).join(""),i=Q(ee(this.baseHash,s)>>>0);if(!t.hasNameForId(r,i)){var a=n(s,"."+i,void 0,r);t.insertRules(r,i,a);}o.push(i),this.staticRulesId=i;}else {for(var c=this.rules.length,u=ee(this.baseHash,n.hash),l="",d=0;d<c;d++){var h=this.rules[d];if("string"==typeof h)l+=h,(u=ee(u,h+d));else if(h){var p=_e(h,e,t,n),f=Array.isArray(p)?p.join(""):p;u=ee(u,f+d),l+=f;}}if(l){var m=Q(u>>>0);if(!t.hasNameForId(r,m)){var y=n(l,"."+m,void 0,r);t.insertRules(r,m,y);}o.push(m);}}return o.join(" ")},e}(),se=/^\s*\/\/.*$/gm,ie=[":","[",".","#"];function ae(e){var t,n,r,o,s=void 0===e?w:e,i=s.options,a=void 0===i?w:i,c=s.plugins,u=void 0===c?S:c,l=new stylis_min(a),d=[],p=function(e){function t(t){if(t)try{e(t+"}");}catch(e){}}return function(n,r,o,s,i,a,c,u,l,d){switch(n){case 1:if(0===l&&64===r.charCodeAt(0))return e(r+";"),"";break;case 2:if(0===u)return r+"/*|*/";break;case 3:switch(u){case 102:case 112:return e(o[0]+r),"";default:return r+(0===d?"/*|*/":"")}case-2:r.split("/*|*/}").forEach(t);}}}((function(e){d.push(e);})),f=function(e,r,s){return 0===r&&-1!==ie.indexOf(s[n.length])||s.match(o)?e:"."+t};function m(e,s,i,a){void 0===a&&(a="&");var c=e.replace(se,""),u=s&&i?i+" "+s+" { "+c+" }":c;return t=a,n=s,r=new RegExp("\\"+n+"\\b","g"),o=new RegExp("(\\"+n+"\\b){2,}"),l(i||!s?"":s,u)}return l.use([].concat(u,[function(e,t,o){2===e&&o.length&&o[0].lastIndexOf(n)>0&&(o[0]=o[0].replace(r,f));},p,function(e){if(-2===e){var t=d;return d=[],t}}])),m.hash=u.length?u.reduce((function(e,t){return t.name||D(15),ee(e,t.name)}),5381).toString():"",m}var ce=React__default["default"].createContext();ce.Consumer;var le=React__default["default"].createContext(),de=(le.Consumer,new X),he=ae();function pe(){return React$4.useContext(ce)||de}function fe(){return React$4.useContext(le)||he}var ye=function(){function e(e,t){var n=this;this.inject=function(e,t){void 0===t&&(t=he);var r=n.name+t.hash;e.hasNameForId(n.id,r)||e.insertRules(n.id,r,t(n.rules,r,"@keyframes"));},this.toString=function(){return D(12,String(n.name))},this.name=e,this.id="sc-keyframes-"+e,this.rules=t;}return e.prototype.getName=function(e){return void 0===e&&(e=he),this.name+e.hash},e}(),ve=/([A-Z])/,ge=/([A-Z])/g,Se=/^ms-/,we=function(e){return "-"+e.toLowerCase()};function Ee(e){return ve.test(e)?e.replace(ge,we).replace(Se,"-ms-"):e}var be=function(e){return null==e||!1===e||""===e};function _e(e,n,r,o){if(Array.isArray(e)){for(var s,i=[],a=0,c=e.length;a<c;a+=1)""!==(s=_e(e[a],n,r,o))&&(Array.isArray(s)?i.push.apply(i,s):i.push(s));return i}if(be(e))return "";if(_(e))return "."+e.styledComponentId;if(E(e)){if("function"!=typeof(l=e)||l.prototype&&l.prototype.isReactComponent||!n)return e;var u=e(n);return reactIs$2.exports.isElement(u)&&console.warn(b(e)+" is not a styled component and cannot be referred to via component selector. See https://www.styled-components.com/docs/advanced#referring-to-other-components for more details."),_e(u,n,r,o)}var l;return e instanceof ye?r?(e.inject(r,o),e.getName(o)):e:g(e)?function e(t,n){var r,o,s=[];for(var i in t)t.hasOwnProperty(i)&&!be(t[i])&&(Array.isArray(t[i])&&t[i].isCss||E(t[i])?s.push(Ee(i)+":",t[i],";"):g(t[i])?s.push.apply(s,e(t[i],i)):s.push(Ee(i)+": "+(r=i,null==(o=t[i])||"boolean"==typeof o||""===o?"":"number"!=typeof o||0===o||r in unitlessKeys?String(o).trim():o+"px")+";"));return n?[n+" {"].concat(s,["}"]):s}(e):e.toString()}var Ne=function(e){return Array.isArray(e)&&(e.isCss=!0),e};function Ae(e){for(var t=arguments.length,n=new Array(t>1?t-1:0),r=1;r<t;r++)n[r-1]=arguments[r];return E(e)||g(e)?Ne(_e(v(S,[e].concat(n)))):0===n.length&&1===e.length&&"string"==typeof e[0]?e:Ne(_e(v(e,n)))}var Ce=/invalid hook call/i,Ie=new Set,Pe=function(e,t){{var n="The component "+e+(t?' with the id of "'+t+'"':"")+" has been created dynamically.\nYou may see this warning because you've called styled inside another component.\nTo resolve this only create new StyledComponents outside of any render method and function component.",r=console.error;try{var o=!0;console.error=function(e){if(Ce.test(e))o=!1,Ie.delete(n);else {for(var t=arguments.length,s=new Array(t>1?t-1:0),i=1;i<t;i++)s[i-1]=arguments[i];r.apply(void 0,[e].concat(s));}},React$4.useRef(),o&&!Ie.has(n)&&(console.warn(n),Ie.add(n));}catch(e){Ce.test(e.message)&&Ie.delete(n);}finally{console.error=r;}}},Oe=function(e,t,n){return void 0===n&&(n=w),e.theme!==n.theme&&e.theme||t||n.theme},Re=/[!"#$%&'()*+,./:;<=>?@[\\\]^`{|}~-]+/g,De=/(^-|-$)/g;function je(e){return e.replace(Re,"-").replace(De,"")}var Te=function(e){return Q(te(e)>>>0)};function xe(e){return "string"==typeof e&&(e.charAt(0)===e.charAt(0).toLowerCase())}var ke=function(e){return "function"==typeof e||"object"==typeof e&&null!==e&&!Array.isArray(e)},Ve=function(e){return "__proto__"!==e&&"constructor"!==e&&"prototype"!==e};function ze(e,t,n){var r=e[n];ke(t)&&ke(r)?Be(r,t):e[n]=t;}function Be(e){for(var t=arguments.length,n=new Array(t>1?t-1:0),r=1;r<t;r++)n[r-1]=arguments[r];for(var o=0,s=n;o<s.length;o++){var i=s[o];if(ke(i))for(var a in i)Ve(a)&&ze(e,i[a],a);}return e}var Me=React__default["default"].createContext();Me.Consumer;var Fe={};function Ye(e,t,n){var o=_(e),i=!xe(e),a=t.attrs,c=void 0===a?S:a,d=t.componentId,h=void 0===d?function(e,t){var n="string"!=typeof e?"sc":je(e);Fe[n]=(Fe[n]||0)+1;var r=n+"-"+Te("5.3.3"+n+Fe[n]);return t?t+"-"+r:r}(t.displayName,t.parentComponentId):d,p=t.displayName,v=void 0===p?function(e){return xe(e)?"styled."+e:"Styled("+b(e)+")"}(e):p,g=t.displayName&&t.componentId?je(t.displayName)+"-"+t.componentId:t.componentId||h,N=o&&e.attrs?Array.prototype.concat(e.attrs,c).filter(Boolean):c,A=t.shouldForwardProp;o&&e.shouldForwardProp&&(A=t.shouldForwardProp?function(n,r,o){return e.shouldForwardProp(n,r,o)&&t.shouldForwardProp(n,r,o)}:e.shouldForwardProp);var C,I=new oe(n,g,o?e.componentStyle:void 0),P=I.isStatic&&0===c.length,O=function(e,t){return function(e,t,n,r){var o=e.attrs,i=e.componentStyle,a=e.defaultProps,c=e.foldedComponentIds,d=e.shouldForwardProp,h=e.styledComponentId,p=e.target;React$4.useDebugValue(h);var m=function(e,t,n){void 0===e&&(e=w);var r=y({},t,{theme:e}),o={};return n.forEach((function(e){var t,n,s,i=e;for(t in E(i)&&(i=i(r)),i)r[t]=o[t]="className"===t?(n=o[t],s=i[t],n&&s?n+" "+s:n||s):i[t];})),[r,o]}(Oe(t,React$4.useContext(Me),a)||w,t,o),v=m[0],g=m[1],S=function(e,t,n,r){var o=pe(),s=fe(),i=t?e.generateAndInjectStyles(w,o,s):e.generateAndInjectStyles(n,o,s);return React$4.useDebugValue(i),!t&&r&&r(i),i}(i,r,v,e.warnTooManyClasses),b=n,_=g.$as||t.$as||g.as||t.as||p,N=xe(_),A=g!==t?y({},t,{},g):t,C={};for(var I in A)"$"!==I[0]&&"as"!==I&&("forwardedAs"===I?C.as=A[I]:(d?d(I,index,_):!N||index(I))&&(C[I]=A[I]));return t.style&&g.style!==t.style&&(C.style=y({},t.style,{},g.style)),C.className=Array.prototype.concat(c,h,S!==h?S:null,t.className,g.className).filter(Boolean).join(" "),C.ref=b,React$4.createElement(_,C)}(C,e,t,P)};return O.displayName=v,(C=React__default["default"].forwardRef(O)).attrs=N,C.componentStyle=I,C.displayName=v,C.shouldForwardProp=A,C.foldedComponentIds=o?Array.prototype.concat(e.foldedComponentIds,e.styledComponentId):S,C.styledComponentId=g,C.target=o?e.target:e,C.withComponent=function(e){var r=t.componentId,o=function(e,t){if(null==e)return {};var n,r,o={},s=Object.keys(e);for(r=0;r<s.length;r++)n=s[r],t.indexOf(n)>=0||(o[n]=e[n]);return o}(t,["componentId"]),s=r&&r+"-"+(xe(e)?e:je(b(e)));return Ye(e,y({},o,{attrs:N,componentId:s}),n)},Object.defineProperty(C,"defaultProps",{get:function(){return this._foldedDefaultProps},set:function(t){this._foldedDefaultProps=o?Be({},e.defaultProps,t):t;}}),(Pe(v,g),C.warnTooManyClasses=function(e,t){var n={},r=!1;return function(o){if(!r&&(n[o]=!0,Object.keys(n).length>=200)){var s=t?' with the id of "'+t+'"':"";console.warn("Over 200 classes were generated for component "+e+s+".\nConsider using the attrs method, together with a style object for frequently changed styles.\nExample:\n  const Component = styled.div.attrs(props => ({\n    style: {\n      background: props.background,\n    },\n  }))`width: 100%;`\n\n  <Component />"),r=!0,n={};}}}(v,g)),C.toString=function(){return "."+C.styledComponentId},i&&hoistNonReactStatics_cjs(C,e,{attrs:!0,componentStyle:!0,displayName:!0,foldedComponentIds:!0,shouldForwardProp:!0,styledComponentId:!0,target:!0,withComponent:!0}),C}var qe=function(e){return function e(t,r,o){if(void 0===o&&(o=w),!reactIs$2.exports.isValidElementType(r))return D(1,String(r));var s=function(){return t(r,o,Ae.apply(void 0,arguments))};return s.withConfig=function(n){return e(t,r,y({},o,{},n))},s.attrs=function(n){return e(t,r,y({},o,{attrs:Array.prototype.concat(o.attrs,n).filter(Boolean)}))},s}(Ye,e)};["a","abbr","address","area","article","aside","audio","b","base","bdi","bdo","big","blockquote","body","br","button","canvas","caption","cite","code","col","colgroup","data","datalist","dd","del","details","dfn","dialog","div","dl","dt","em","embed","fieldset","figcaption","figure","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","iframe","img","input","ins","kbd","keygen","label","legend","li","link","main","map","mark","marquee","menu","menuitem","meta","meter","nav","noscript","object","ol","optgroup","option","output","p","param","picture","pre","progress","q","rp","rt","ruby","s","samp","script","section","select","small","source","span","strong","style","sub","summary","sup","table","tbody","td","textarea","tfoot","th","thead","time","title","tr","track","u","ul","var","video","wbr","circle","clipPath","defs","ellipse","foreignObject","g","image","line","linearGradient","marker","mask","path","pattern","polygon","polyline","radialGradient","rect","stop","svg","text","textPath","tspan"].forEach((function(e){qe[e]=qe(e);}));"undefined"!=typeof navigator&&"ReactNative"===navigator.product&&console.warn("It looks like you've imported 'styled-components' on React Native.\nPerhaps you're looking to import 'styled-components/native'?\nRead more about this at https://www.styled-components.com/docs/basics#react-native"),"undefined"!=typeof window&&(window["__styled-components-init__"]=window["__styled-components-init__"]||0,1===window["__styled-components-init__"]&&console.warn("It looks like there are several instances of 'styled-components' initialized in this application. This may cause dynamic styles to not render properly, errors during the rehydration process, a missing theme prop, and makes your application bigger without good reason.\n\nSee https://s-c.sh/2BAXzed for more info."),window["__styled-components-init__"]+=1);var styled = qe;

	var InfoCircleOutlined$5 = {exports: {}};

	var InfoCircleOutlined$4 = {};

	var interopRequireWildcard = {exports: {}};

	var _typeof = {exports: {}};

	(function (module) {
	function _typeof(obj) {
	  "@babel/helpers - typeof";

	  return (module.exports = _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) {
	    return typeof obj;
	  } : function (obj) {
	    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
	  }, module.exports.__esModule = true, module.exports["default"] = module.exports), _typeof(obj);
	}

	module.exports = _typeof, module.exports.__esModule = true, module.exports["default"] = module.exports;
	}(_typeof));

	(function (module) {
	var _typeof$1 = _typeof.exports["default"];

	function _getRequireWildcardCache(nodeInterop) {
	  if (typeof WeakMap !== "function") return null;
	  var cacheBabelInterop = new WeakMap();
	  var cacheNodeInterop = new WeakMap();
	  return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) {
	    return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
	  })(nodeInterop);
	}

	function _interopRequireWildcard(obj, nodeInterop) {
	  if (!nodeInterop && obj && obj.__esModule) {
	    return obj;
	  }

	  if (obj === null || _typeof$1(obj) !== "object" && typeof obj !== "function") {
	    return {
	      "default": obj
	    };
	  }

	  var cache = _getRequireWildcardCache(nodeInterop);

	  if (cache && cache.has(obj)) {
	    return cache.get(obj);
	  }

	  var newObj = {};
	  var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;

	  for (var key in obj) {
	    if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
	      var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;

	      if (desc && (desc.get || desc.set)) {
	        Object.defineProperty(newObj, key, desc);
	      } else {
	        newObj[key] = obj[key];
	      }
	    }
	  }

	  newObj["default"] = obj;

	  if (cache) {
	    cache.set(obj, newObj);
	  }

	  return newObj;
	}

	module.exports = _interopRequireWildcard, module.exports.__esModule = true, module.exports["default"] = module.exports;
	}(interopRequireWildcard));

	var interopRequireDefault$1 = {exports: {}};

	(function (module) {
	function _interopRequireDefault(obj) {
	  return obj && obj.__esModule ? obj : {
	    "default": obj
	  };
	}

	module.exports = _interopRequireDefault, module.exports.__esModule = true, module.exports["default"] = module.exports;
	}(interopRequireDefault$1));

	var objectSpread2 = {exports: {}};

	var defineProperty = {exports: {}};

	(function (module) {
	function _defineProperty(obj, key, value) {
	  if (key in obj) {
	    Object.defineProperty(obj, key, {
	      value: value,
	      enumerable: true,
	      configurable: true,
	      writable: true
	    });
	  } else {
	    obj[key] = value;
	  }

	  return obj;
	}

	module.exports = _defineProperty, module.exports.__esModule = true, module.exports["default"] = module.exports;
	}(defineProperty));

	(function (module) {
	var defineProperty$1 = defineProperty.exports;

	function ownKeys(object, enumerableOnly) {
	  var keys = Object.keys(object);

	  if (Object.getOwnPropertySymbols) {
	    var symbols = Object.getOwnPropertySymbols(object);
	    enumerableOnly && (symbols = symbols.filter(function (sym) {
	      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
	    })), keys.push.apply(keys, symbols);
	  }

	  return keys;
	}

	function _objectSpread2(target) {
	  for (var i = 1; i < arguments.length; i++) {
	    var source = null != arguments[i] ? arguments[i] : {};
	    i % 2 ? ownKeys(Object(source), !0).forEach(function (key) {
	      defineProperty$1(target, key, source[key]);
	    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) {
	      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
	    });
	  }

	  return target;
	}

	module.exports = _objectSpread2, module.exports.__esModule = true, module.exports["default"] = module.exports;
	}(objectSpread2));

	var InfoCircleOutlined$3 = {};

	// This icon file is generated automatically.
	Object.defineProperty(InfoCircleOutlined$3, "__esModule", { value: true });
	var InfoCircleOutlined$2 = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M512 64C264.6 64 64 264.6 64 512s200.6 448 448 448 448-200.6 448-448S759.4 64 512 64zm0 820c-205.4 0-372-166.6-372-372s166.6-372 372-372 372 166.6 372 372-166.6 372-372 372z" } }, { "tag": "path", "attrs": { "d": "M464 336a48 48 0 1096 0 48 48 0 10-96 0zm72 112h-48c-4.4 0-8 3.6-8 8v272c0 4.4 3.6 8 8 8h48c4.4 0 8-3.6 8-8V456c0-4.4-3.6-8-8-8z" } }] }, "name": "info-circle", "theme": "outlined" };
	InfoCircleOutlined$3.default = InfoCircleOutlined$2;

	var AntdIcon = {};

	var slicedToArray = {exports: {}};

	var arrayWithHoles = {exports: {}};

	(function (module) {
	function _arrayWithHoles(arr) {
	  if (Array.isArray(arr)) return arr;
	}

	module.exports = _arrayWithHoles, module.exports.__esModule = true, module.exports["default"] = module.exports;
	}(arrayWithHoles));

	var iterableToArrayLimit = {exports: {}};

	(function (module) {
	function _iterableToArrayLimit(arr, i) {
	  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

	  if (_i == null) return;
	  var _arr = [];
	  var _n = true;
	  var _d = false;

	  var _s, _e;

	  try {
	    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
	      _arr.push(_s.value);

	      if (i && _arr.length === i) break;
	    }
	  } catch (err) {
	    _d = true;
	    _e = err;
	  } finally {
	    try {
	      if (!_n && _i["return"] != null) _i["return"]();
	    } finally {
	      if (_d) throw _e;
	    }
	  }

	  return _arr;
	}

	module.exports = _iterableToArrayLimit, module.exports.__esModule = true, module.exports["default"] = module.exports;
	}(iterableToArrayLimit));

	var unsupportedIterableToArray = {exports: {}};

	var arrayLikeToArray = {exports: {}};

	(function (module) {
	function _arrayLikeToArray(arr, len) {
	  if (len == null || len > arr.length) len = arr.length;

	  for (var i = 0, arr2 = new Array(len); i < len; i++) {
	    arr2[i] = arr[i];
	  }

	  return arr2;
	}

	module.exports = _arrayLikeToArray, module.exports.__esModule = true, module.exports["default"] = module.exports;
	}(arrayLikeToArray));

	(function (module) {
	var arrayLikeToArray$1 = arrayLikeToArray.exports;

	function _unsupportedIterableToArray(o, minLen) {
	  if (!o) return;
	  if (typeof o === "string") return arrayLikeToArray$1(o, minLen);
	  var n = Object.prototype.toString.call(o).slice(8, -1);
	  if (n === "Object" && o.constructor) n = o.constructor.name;
	  if (n === "Map" || n === "Set") return Array.from(o);
	  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return arrayLikeToArray$1(o, minLen);
	}

	module.exports = _unsupportedIterableToArray, module.exports.__esModule = true, module.exports["default"] = module.exports;
	}(unsupportedIterableToArray));

	var nonIterableRest = {exports: {}};

	(function (module) {
	function _nonIterableRest() {
	  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
	}

	module.exports = _nonIterableRest, module.exports.__esModule = true, module.exports["default"] = module.exports;
	}(nonIterableRest));

	(function (module) {
	var arrayWithHoles$1 = arrayWithHoles.exports;

	var iterableToArrayLimit$1 = iterableToArrayLimit.exports;

	var unsupportedIterableToArray$1 = unsupportedIterableToArray.exports;

	var nonIterableRest$1 = nonIterableRest.exports;

	function _slicedToArray(arr, i) {
	  return arrayWithHoles$1(arr) || iterableToArrayLimit$1(arr, i) || unsupportedIterableToArray$1(arr, i) || nonIterableRest$1();
	}

	module.exports = _slicedToArray, module.exports.__esModule = true, module.exports["default"] = module.exports;
	}(slicedToArray));

	var objectWithoutProperties = {exports: {}};

	var objectWithoutPropertiesLoose = {exports: {}};

	(function (module) {
	function _objectWithoutPropertiesLoose(source, excluded) {
	  if (source == null) return {};
	  var target = {};
	  var sourceKeys = Object.keys(source);
	  var key, i;

	  for (i = 0; i < sourceKeys.length; i++) {
	    key = sourceKeys[i];
	    if (excluded.indexOf(key) >= 0) continue;
	    target[key] = source[key];
	  }

	  return target;
	}

	module.exports = _objectWithoutPropertiesLoose, module.exports.__esModule = true, module.exports["default"] = module.exports;
	}(objectWithoutPropertiesLoose));

	(function (module) {
	var objectWithoutPropertiesLoose$1 = objectWithoutPropertiesLoose.exports;

	function _objectWithoutProperties(source, excluded) {
	  if (source == null) return {};
	  var target = objectWithoutPropertiesLoose$1(source, excluded);
	  var key, i;

	  if (Object.getOwnPropertySymbols) {
	    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

	    for (i = 0; i < sourceSymbolKeys.length; i++) {
	      key = sourceSymbolKeys[i];
	      if (excluded.indexOf(key) >= 0) continue;
	      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
	      target[key] = source[key];
	    }
	  }

	  return target;
	}

	module.exports = _objectWithoutProperties, module.exports.__esModule = true, module.exports["default"] = module.exports;
	}(objectWithoutProperties));

	var classnames = {exports: {}};

	/*!
	  Copyright (c) 2018 Jed Watson.
	  Licensed under the MIT License (MIT), see
	  http://jedwatson.github.io/classnames
	*/

	(function (module) {
	/* global define */

	(function () {

		var hasOwn = {}.hasOwnProperty;

		function classNames() {
			var classes = [];

			for (var i = 0; i < arguments.length; i++) {
				var arg = arguments[i];
				if (!arg) continue;

				var argType = typeof arg;

				if (argType === 'string' || argType === 'number') {
					classes.push(arg);
				} else if (Array.isArray(arg)) {
					if (arg.length) {
						var inner = classNames.apply(null, arg);
						if (inner) {
							classes.push(inner);
						}
					}
				} else if (argType === 'object') {
					if (arg.toString === Object.prototype.toString) {
						for (var key in arg) {
							if (hasOwn.call(arg, key) && arg[key]) {
								classes.push(key);
							}
						}
					} else {
						classes.push(arg.toString());
					}
				}
			}

			return classes.join(' ');
		}

		if (module.exports) {
			classNames.default = classNames;
			module.exports = classNames;
		} else {
			window.classNames = classNames;
		}
	}());
	}(classnames));

	var Context = {};

	Object.defineProperty(Context, "__esModule", {
	  value: true
	});
	Context.default = void 0;

	var _react$1 = React__default["default"];

	var IconContext = /*#__PURE__*/(0, _react$1.createContext)({});
	var _default$6 = IconContext;
	Context.default = _default$6;

	var IconBase$1 = {};

	var utils = {};

	/**
	 * Take input from [0, n] and return it as [0, 1]
	 * @hidden
	 */
	function bound01(n, max) {
	    if (isOnePointZero(n)) {
	        n = '100%';
	    }
	    var isPercent = isPercentage(n);
	    n = max === 360 ? n : Math.min(max, Math.max(0, parseFloat(n)));
	    // Automatically convert percentage into number
	    if (isPercent) {
	        n = parseInt(String(n * max), 10) / 100;
	    }
	    // Handle floating point rounding errors
	    if (Math.abs(n - max) < 0.000001) {
	        return 1;
	    }
	    // Convert into [0, 1] range if it isn't already
	    if (max === 360) {
	        // If n is a hue given in degrees,
	        // wrap around out-of-range values into [0, 360] range
	        // then convert into [0, 1].
	        n = (n < 0 ? (n % max) + max : n % max) / parseFloat(String(max));
	    }
	    else {
	        // If n not a hue given in degrees
	        // Convert into [0, 1] range if it isn't already.
	        n = (n % max) / parseFloat(String(max));
	    }
	    return n;
	}
	/**
	 * Need to handle 1.0 as 100%, since once it is a number, there is no difference between it and 1
	 * <http://stackoverflow.com/questions/7422072/javascript-how-to-detect-number-as-a-decimal-including-1-0>
	 * @hidden
	 */
	function isOnePointZero(n) {
	    return typeof n === 'string' && n.indexOf('.') !== -1 && parseFloat(n) === 1;
	}
	/**
	 * Check to see if string passed in is a percentage
	 * @hidden
	 */
	function isPercentage(n) {
	    return typeof n === 'string' && n.indexOf('%') !== -1;
	}
	/**
	 * Return a valid alpha value [0,1] with all invalid values being set to 1
	 * @hidden
	 */
	function boundAlpha(a) {
	    a = parseFloat(a);
	    if (isNaN(a) || a < 0 || a > 1) {
	        a = 1;
	    }
	    return a;
	}
	/**
	 * Replace a decimal with it's percentage value
	 * @hidden
	 */
	function convertToPercentage(n) {
	    if (n <= 1) {
	        return Number(n) * 100 + "%";
	    }
	    return n;
	}
	/**
	 * Force a hex value to have 2 characters
	 * @hidden
	 */
	function pad2(c) {
	    return c.length === 1 ? '0' + c : String(c);
	}

	// `rgbToHsl`, `rgbToHsv`, `hslToRgb`, `hsvToRgb` modified from:
	// <http://mjijackson.com/2008/02/rgb-to-hsl-and-rgb-to-hsv-color-model-conversion-algorithms-in-javascript>
	/**
	 * Handle bounds / percentage checking to conform to CSS color spec
	 * <http://www.w3.org/TR/css3-color/>
	 * *Assumes:* r, g, b in [0, 255] or [0, 1]
	 * *Returns:* { r, g, b } in [0, 255]
	 */
	function rgbToRgb(r, g, b) {
	    return {
	        r: bound01(r, 255) * 255,
	        g: bound01(g, 255) * 255,
	        b: bound01(b, 255) * 255,
	    };
	}
	function hue2rgb(p, q, t) {
	    if (t < 0) {
	        t += 1;
	    }
	    if (t > 1) {
	        t -= 1;
	    }
	    if (t < 1 / 6) {
	        return p + (q - p) * (6 * t);
	    }
	    if (t < 1 / 2) {
	        return q;
	    }
	    if (t < 2 / 3) {
	        return p + (q - p) * (2 / 3 - t) * 6;
	    }
	    return p;
	}
	/**
	 * Converts an HSL color value to RGB.
	 *
	 * *Assumes:* h is contained in [0, 1] or [0, 360] and s and l are contained [0, 1] or [0, 100]
	 * *Returns:* { r, g, b } in the set [0, 255]
	 */
	function hslToRgb(h, s, l) {
	    var r;
	    var g;
	    var b;
	    h = bound01(h, 360);
	    s = bound01(s, 100);
	    l = bound01(l, 100);
	    if (s === 0) {
	        // achromatic
	        g = l;
	        b = l;
	        r = l;
	    }
	    else {
	        var q = l < 0.5 ? l * (1 + s) : l + s - l * s;
	        var p = 2 * l - q;
	        r = hue2rgb(p, q, h + 1 / 3);
	        g = hue2rgb(p, q, h);
	        b = hue2rgb(p, q, h - 1 / 3);
	    }
	    return { r: r * 255, g: g * 255, b: b * 255 };
	}
	/**
	 * Converts an RGB color value to HSV
	 *
	 * *Assumes:* r, g, and b are contained in the set [0, 255] or [0, 1]
	 * *Returns:* { h, s, v } in [0,1]
	 */
	function rgbToHsv(r, g, b) {
	    r = bound01(r, 255);
	    g = bound01(g, 255);
	    b = bound01(b, 255);
	    var max = Math.max(r, g, b);
	    var min = Math.min(r, g, b);
	    var h = 0;
	    var v = max;
	    var d = max - min;
	    var s = max === 0 ? 0 : d / max;
	    if (max === min) {
	        h = 0; // achromatic
	    }
	    else {
	        switch (max) {
	            case r:
	                h = (g - b) / d + (g < b ? 6 : 0);
	                break;
	            case g:
	                h = (b - r) / d + 2;
	                break;
	            case b:
	                h = (r - g) / d + 4;
	                break;
	        }
	        h /= 6;
	    }
	    return { h: h, s: s, v: v };
	}
	/**
	 * Converts an HSV color value to RGB.
	 *
	 * *Assumes:* h is contained in [0, 1] or [0, 360] and s and v are contained in [0, 1] or [0, 100]
	 * *Returns:* { r, g, b } in the set [0, 255]
	 */
	function hsvToRgb(h, s, v) {
	    h = bound01(h, 360) * 6;
	    s = bound01(s, 100);
	    v = bound01(v, 100);
	    var i = Math.floor(h);
	    var f = h - i;
	    var p = v * (1 - s);
	    var q = v * (1 - f * s);
	    var t = v * (1 - (1 - f) * s);
	    var mod = i % 6;
	    var r = [v, q, p, p, t, v][mod];
	    var g = [t, v, v, q, p, p][mod];
	    var b = [p, p, t, v, v, q][mod];
	    return { r: r * 255, g: g * 255, b: b * 255 };
	}
	/**
	 * Converts an RGB color to hex
	 *
	 * Assumes r, g, and b are contained in the set [0, 255]
	 * Returns a 3 or 6 character hex
	 */
	function rgbToHex(r, g, b, allow3Char) {
	    var hex = [
	        pad2(Math.round(r).toString(16)),
	        pad2(Math.round(g).toString(16)),
	        pad2(Math.round(b).toString(16)),
	    ];
	    // Return a 3 character hex if possible
	    if (allow3Char &&
	        hex[0].startsWith(hex[0].charAt(1)) &&
	        hex[1].startsWith(hex[1].charAt(1)) &&
	        hex[2].startsWith(hex[2].charAt(1))) {
	        return hex[0].charAt(0) + hex[1].charAt(0) + hex[2].charAt(0);
	    }
	    return hex.join('');
	}
	/** Converts a hex value to a decimal */
	function convertHexToDecimal(h) {
	    return parseIntFromHex(h) / 255;
	}
	/** Parse a base-16 hex value into a base-10 integer */
	function parseIntFromHex(val) {
	    return parseInt(val, 16);
	}

	// https://github.com/bahamas10/css-color-names/blob/master/css-color-names.json
	/**
	 * @hidden
	 */
	var names = {
	    aliceblue: '#f0f8ff',
	    antiquewhite: '#faebd7',
	    aqua: '#00ffff',
	    aquamarine: '#7fffd4',
	    azure: '#f0ffff',
	    beige: '#f5f5dc',
	    bisque: '#ffe4c4',
	    black: '#000000',
	    blanchedalmond: '#ffebcd',
	    blue: '#0000ff',
	    blueviolet: '#8a2be2',
	    brown: '#a52a2a',
	    burlywood: '#deb887',
	    cadetblue: '#5f9ea0',
	    chartreuse: '#7fff00',
	    chocolate: '#d2691e',
	    coral: '#ff7f50',
	    cornflowerblue: '#6495ed',
	    cornsilk: '#fff8dc',
	    crimson: '#dc143c',
	    cyan: '#00ffff',
	    darkblue: '#00008b',
	    darkcyan: '#008b8b',
	    darkgoldenrod: '#b8860b',
	    darkgray: '#a9a9a9',
	    darkgreen: '#006400',
	    darkgrey: '#a9a9a9',
	    darkkhaki: '#bdb76b',
	    darkmagenta: '#8b008b',
	    darkolivegreen: '#556b2f',
	    darkorange: '#ff8c00',
	    darkorchid: '#9932cc',
	    darkred: '#8b0000',
	    darksalmon: '#e9967a',
	    darkseagreen: '#8fbc8f',
	    darkslateblue: '#483d8b',
	    darkslategray: '#2f4f4f',
	    darkslategrey: '#2f4f4f',
	    darkturquoise: '#00ced1',
	    darkviolet: '#9400d3',
	    deeppink: '#ff1493',
	    deepskyblue: '#00bfff',
	    dimgray: '#696969',
	    dimgrey: '#696969',
	    dodgerblue: '#1e90ff',
	    firebrick: '#b22222',
	    floralwhite: '#fffaf0',
	    forestgreen: '#228b22',
	    fuchsia: '#ff00ff',
	    gainsboro: '#dcdcdc',
	    ghostwhite: '#f8f8ff',
	    goldenrod: '#daa520',
	    gold: '#ffd700',
	    gray: '#808080',
	    green: '#008000',
	    greenyellow: '#adff2f',
	    grey: '#808080',
	    honeydew: '#f0fff0',
	    hotpink: '#ff69b4',
	    indianred: '#cd5c5c',
	    indigo: '#4b0082',
	    ivory: '#fffff0',
	    khaki: '#f0e68c',
	    lavenderblush: '#fff0f5',
	    lavender: '#e6e6fa',
	    lawngreen: '#7cfc00',
	    lemonchiffon: '#fffacd',
	    lightblue: '#add8e6',
	    lightcoral: '#f08080',
	    lightcyan: '#e0ffff',
	    lightgoldenrodyellow: '#fafad2',
	    lightgray: '#d3d3d3',
	    lightgreen: '#90ee90',
	    lightgrey: '#d3d3d3',
	    lightpink: '#ffb6c1',
	    lightsalmon: '#ffa07a',
	    lightseagreen: '#20b2aa',
	    lightskyblue: '#87cefa',
	    lightslategray: '#778899',
	    lightslategrey: '#778899',
	    lightsteelblue: '#b0c4de',
	    lightyellow: '#ffffe0',
	    lime: '#00ff00',
	    limegreen: '#32cd32',
	    linen: '#faf0e6',
	    magenta: '#ff00ff',
	    maroon: '#800000',
	    mediumaquamarine: '#66cdaa',
	    mediumblue: '#0000cd',
	    mediumorchid: '#ba55d3',
	    mediumpurple: '#9370db',
	    mediumseagreen: '#3cb371',
	    mediumslateblue: '#7b68ee',
	    mediumspringgreen: '#00fa9a',
	    mediumturquoise: '#48d1cc',
	    mediumvioletred: '#c71585',
	    midnightblue: '#191970',
	    mintcream: '#f5fffa',
	    mistyrose: '#ffe4e1',
	    moccasin: '#ffe4b5',
	    navajowhite: '#ffdead',
	    navy: '#000080',
	    oldlace: '#fdf5e6',
	    olive: '#808000',
	    olivedrab: '#6b8e23',
	    orange: '#ffa500',
	    orangered: '#ff4500',
	    orchid: '#da70d6',
	    palegoldenrod: '#eee8aa',
	    palegreen: '#98fb98',
	    paleturquoise: '#afeeee',
	    palevioletred: '#db7093',
	    papayawhip: '#ffefd5',
	    peachpuff: '#ffdab9',
	    peru: '#cd853f',
	    pink: '#ffc0cb',
	    plum: '#dda0dd',
	    powderblue: '#b0e0e6',
	    purple: '#800080',
	    rebeccapurple: '#663399',
	    red: '#ff0000',
	    rosybrown: '#bc8f8f',
	    royalblue: '#4169e1',
	    saddlebrown: '#8b4513',
	    salmon: '#fa8072',
	    sandybrown: '#f4a460',
	    seagreen: '#2e8b57',
	    seashell: '#fff5ee',
	    sienna: '#a0522d',
	    silver: '#c0c0c0',
	    skyblue: '#87ceeb',
	    slateblue: '#6a5acd',
	    slategray: '#708090',
	    slategrey: '#708090',
	    snow: '#fffafa',
	    springgreen: '#00ff7f',
	    steelblue: '#4682b4',
	    tan: '#d2b48c',
	    teal: '#008080',
	    thistle: '#d8bfd8',
	    tomato: '#ff6347',
	    turquoise: '#40e0d0',
	    violet: '#ee82ee',
	    wheat: '#f5deb3',
	    white: '#ffffff',
	    whitesmoke: '#f5f5f5',
	    yellow: '#ffff00',
	    yellowgreen: '#9acd32',
	};

	/**
	 * Given a string or object, convert that input to RGB
	 *
	 * Possible string inputs:
	 * ```
	 * "red"
	 * "#f00" or "f00"
	 * "#ff0000" or "ff0000"
	 * "#ff000000" or "ff000000"
	 * "rgb 255 0 0" or "rgb (255, 0, 0)"
	 * "rgb 1.0 0 0" or "rgb (1, 0, 0)"
	 * "rgba (255, 0, 0, 1)" or "rgba 255, 0, 0, 1"
	 * "rgba (1.0, 0, 0, 1)" or "rgba 1.0, 0, 0, 1"
	 * "hsl(0, 100%, 50%)" or "hsl 0 100% 50%"
	 * "hsla(0, 100%, 50%, 1)" or "hsla 0 100% 50%, 1"
	 * "hsv(0, 100%, 100%)" or "hsv 0 100% 100%"
	 * ```
	 */
	function inputToRGB(color) {
	    var rgb = { r: 0, g: 0, b: 0 };
	    var a = 1;
	    var s = null;
	    var v = null;
	    var l = null;
	    var ok = false;
	    var format = false;
	    if (typeof color === 'string') {
	        color = stringInputToObject(color);
	    }
	    if (typeof color === 'object') {
	        if (isValidCSSUnit(color.r) && isValidCSSUnit(color.g) && isValidCSSUnit(color.b)) {
	            rgb = rgbToRgb(color.r, color.g, color.b);
	            ok = true;
	            format = String(color.r).substr(-1) === '%' ? 'prgb' : 'rgb';
	        }
	        else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.v)) {
	            s = convertToPercentage(color.s);
	            v = convertToPercentage(color.v);
	            rgb = hsvToRgb(color.h, s, v);
	            ok = true;
	            format = 'hsv';
	        }
	        else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.l)) {
	            s = convertToPercentage(color.s);
	            l = convertToPercentage(color.l);
	            rgb = hslToRgb(color.h, s, l);
	            ok = true;
	            format = 'hsl';
	        }
	        if (Object.prototype.hasOwnProperty.call(color, 'a')) {
	            a = color.a;
	        }
	    }
	    a = boundAlpha(a);
	    return {
	        ok: ok,
	        format: color.format || format,
	        r: Math.min(255, Math.max(rgb.r, 0)),
	        g: Math.min(255, Math.max(rgb.g, 0)),
	        b: Math.min(255, Math.max(rgb.b, 0)),
	        a: a,
	    };
	}
	// <http://www.w3.org/TR/css3-values/#integers>
	var CSS_INTEGER = '[-\\+]?\\d+%?';
	// <http://www.w3.org/TR/css3-values/#number-value>
	var CSS_NUMBER = '[-\\+]?\\d*\\.\\d+%?';
	// Allow positive/negative integer/number.  Don't capture the either/or, just the entire outcome.
	var CSS_UNIT = "(?:" + CSS_NUMBER + ")|(?:" + CSS_INTEGER + ")";
	// Actual matching.
	// Parentheses and commas are optional, but not required.
	// Whitespace can take the place of commas or opening paren
	var PERMISSIVE_MATCH3 = "[\\s|\\(]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")\\s*\\)?";
	var PERMISSIVE_MATCH4 = "[\\s|\\(]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")\\s*\\)?";
	var matchers = {
	    CSS_UNIT: new RegExp(CSS_UNIT),
	    rgb: new RegExp('rgb' + PERMISSIVE_MATCH3),
	    rgba: new RegExp('rgba' + PERMISSIVE_MATCH4),
	    hsl: new RegExp('hsl' + PERMISSIVE_MATCH3),
	    hsla: new RegExp('hsla' + PERMISSIVE_MATCH4),
	    hsv: new RegExp('hsv' + PERMISSIVE_MATCH3),
	    hsva: new RegExp('hsva' + PERMISSIVE_MATCH4),
	    hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
	    hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,
	    hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
	    hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,
	};
	/**
	 * Permissive string parsing.  Take in a number of formats, and output an object
	 * based on detected format.  Returns `{ r, g, b }` or `{ h, s, l }` or `{ h, s, v}`
	 */
	function stringInputToObject(color) {
	    color = color.trim().toLowerCase();
	    if (color.length === 0) {
	        return false;
	    }
	    var named = false;
	    if (names[color]) {
	        color = names[color];
	        named = true;
	    }
	    else if (color === 'transparent') {
	        return { r: 0, g: 0, b: 0, a: 0, format: 'name' };
	    }
	    // Try to match string input using regular expressions.
	    // Keep most of the number bounding out of this function - don't worry about [0,1] or [0,100] or [0,360]
	    // Just return an object and let the conversion functions handle that.
	    // This way the result will be the same whether the tinycolor is initialized with string or object.
	    var match = matchers.rgb.exec(color);
	    if (match) {
	        return { r: match[1], g: match[2], b: match[3] };
	    }
	    match = matchers.rgba.exec(color);
	    if (match) {
	        return { r: match[1], g: match[2], b: match[3], a: match[4] };
	    }
	    match = matchers.hsl.exec(color);
	    if (match) {
	        return { h: match[1], s: match[2], l: match[3] };
	    }
	    match = matchers.hsla.exec(color);
	    if (match) {
	        return { h: match[1], s: match[2], l: match[3], a: match[4] };
	    }
	    match = matchers.hsv.exec(color);
	    if (match) {
	        return { h: match[1], s: match[2], v: match[3] };
	    }
	    match = matchers.hsva.exec(color);
	    if (match) {
	        return { h: match[1], s: match[2], v: match[3], a: match[4] };
	    }
	    match = matchers.hex8.exec(color);
	    if (match) {
	        return {
	            r: parseIntFromHex(match[1]),
	            g: parseIntFromHex(match[2]),
	            b: parseIntFromHex(match[3]),
	            a: convertHexToDecimal(match[4]),
	            format: named ? 'name' : 'hex8',
	        };
	    }
	    match = matchers.hex6.exec(color);
	    if (match) {
	        return {
	            r: parseIntFromHex(match[1]),
	            g: parseIntFromHex(match[2]),
	            b: parseIntFromHex(match[3]),
	            format: named ? 'name' : 'hex',
	        };
	    }
	    match = matchers.hex4.exec(color);
	    if (match) {
	        return {
	            r: parseIntFromHex(match[1] + match[1]),
	            g: parseIntFromHex(match[2] + match[2]),
	            b: parseIntFromHex(match[3] + match[3]),
	            a: convertHexToDecimal(match[4] + match[4]),
	            format: named ? 'name' : 'hex8',
	        };
	    }
	    match = matchers.hex3.exec(color);
	    if (match) {
	        return {
	            r: parseIntFromHex(match[1] + match[1]),
	            g: parseIntFromHex(match[2] + match[2]),
	            b: parseIntFromHex(match[3] + match[3]),
	            format: named ? 'name' : 'hex',
	        };
	    }
	    return false;
	}
	/**
	 * Check to see if it looks like a CSS unit
	 * (see `matchers` above for definition).
	 */
	function isValidCSSUnit(color) {
	    return Boolean(matchers.CSS_UNIT.exec(String(color)));
	}

	var hueStep = 2; // 色相阶梯

	var saturationStep = 0.16; // 饱和度阶梯，浅色部分

	var saturationStep2 = 0.05; // 饱和度阶梯，深色部分

	var brightnessStep1 = 0.05; // 亮度阶梯，浅色部分

	var brightnessStep2 = 0.15; // 亮度阶梯，深色部分

	var lightColorCount = 5; // 浅色数量，主色上

	var darkColorCount = 4; // 深色数量，主色下
	// 暗色主题颜色映射关系表

	var darkColorMap = [{
	  index: 7,
	  opacity: 0.15
	}, {
	  index: 6,
	  opacity: 0.25
	}, {
	  index: 5,
	  opacity: 0.3
	}, {
	  index: 5,
	  opacity: 0.45
	}, {
	  index: 5,
	  opacity: 0.65
	}, {
	  index: 5,
	  opacity: 0.85
	}, {
	  index: 4,
	  opacity: 0.9
	}, {
	  index: 3,
	  opacity: 0.95
	}, {
	  index: 2,
	  opacity: 0.97
	}, {
	  index: 1,
	  opacity: 0.98
	}]; // Wrapper function ported from TinyColor.prototype.toHsv
	// Keep it here because of `hsv.h * 360`

	function toHsv(_ref) {
	  var r = _ref.r,
	      g = _ref.g,
	      b = _ref.b;
	  var hsv = rgbToHsv(r, g, b);
	  return {
	    h: hsv.h * 360,
	    s: hsv.s,
	    v: hsv.v
	  };
	} // Wrapper function ported from TinyColor.prototype.toHexString
	// Keep it here because of the prefix `#`


	function toHex(_ref2) {
	  var r = _ref2.r,
	      g = _ref2.g,
	      b = _ref2.b;
	  return "#".concat(rgbToHex(r, g, b, false));
	} // Wrapper function ported from TinyColor.prototype.mix, not treeshakable.
	// Amount in range [0, 1]
	// Assume color1 & color2 has no alpha, since the following src code did so.


	function mix(rgb1, rgb2, amount) {
	  var p = amount / 100;
	  var rgb = {
	    r: (rgb2.r - rgb1.r) * p + rgb1.r,
	    g: (rgb2.g - rgb1.g) * p + rgb1.g,
	    b: (rgb2.b - rgb1.b) * p + rgb1.b
	  };
	  return rgb;
	}

	function getHue(hsv, i, light) {
	  var hue; // 根据色相不同，色相转向不同

	  if (Math.round(hsv.h) >= 60 && Math.round(hsv.h) <= 240) {
	    hue = light ? Math.round(hsv.h) - hueStep * i : Math.round(hsv.h) + hueStep * i;
	  } else {
	    hue = light ? Math.round(hsv.h) + hueStep * i : Math.round(hsv.h) - hueStep * i;
	  }

	  if (hue < 0) {
	    hue += 360;
	  } else if (hue >= 360) {
	    hue -= 360;
	  }

	  return hue;
	}

	function getSaturation(hsv, i, light) {
	  // grey color don't change saturation
	  if (hsv.h === 0 && hsv.s === 0) {
	    return hsv.s;
	  }

	  var saturation;

	  if (light) {
	    saturation = hsv.s - saturationStep * i;
	  } else if (i === darkColorCount) {
	    saturation = hsv.s + saturationStep;
	  } else {
	    saturation = hsv.s + saturationStep2 * i;
	  } // 边界值修正


	  if (saturation > 1) {
	    saturation = 1;
	  } // 第一格的 s 限制在 0.06-0.1 之间


	  if (light && i === lightColorCount && saturation > 0.1) {
	    saturation = 0.1;
	  }

	  if (saturation < 0.06) {
	    saturation = 0.06;
	  }

	  return Number(saturation.toFixed(2));
	}

	function getValue(hsv, i, light) {
	  var value;

	  if (light) {
	    value = hsv.v + brightnessStep1 * i;
	  } else {
	    value = hsv.v - brightnessStep2 * i;
	  }

	  if (value > 1) {
	    value = 1;
	  }

	  return Number(value.toFixed(2));
	}

	function generate$1(color) {
	  var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
	  var patterns = [];
	  var pColor = inputToRGB(color);

	  for (var i = lightColorCount; i > 0; i -= 1) {
	    var hsv = toHsv(pColor);
	    var colorString = toHex(inputToRGB({
	      h: getHue(hsv, i, true),
	      s: getSaturation(hsv, i, true),
	      v: getValue(hsv, i, true)
	    }));
	    patterns.push(colorString);
	  }

	  patterns.push(toHex(pColor));

	  for (var _i = 1; _i <= darkColorCount; _i += 1) {
	    var _hsv = toHsv(pColor);

	    var _colorString = toHex(inputToRGB({
	      h: getHue(_hsv, _i),
	      s: getSaturation(_hsv, _i),
	      v: getValue(_hsv, _i)
	    }));

	    patterns.push(_colorString);
	  } // dark theme patterns


	  if (opts.theme === 'dark') {
	    return darkColorMap.map(function (_ref3) {
	      var index = _ref3.index,
	          opacity = _ref3.opacity;
	      var darkColorString = toHex(mix(inputToRGB(opts.backgroundColor || '#141414'), inputToRGB(patterns[index]), opacity * 100));
	      return darkColorString;
	    });
	  }

	  return patterns;
	}

	var presetPrimaryColors = {
	  red: '#F5222D',
	  volcano: '#FA541C',
	  orange: '#FA8C16',
	  gold: '#FAAD14',
	  yellow: '#FADB14',
	  lime: '#A0D911',
	  green: '#52C41A',
	  cyan: '#13C2C2',
	  blue: '#1890FF',
	  geekblue: '#2F54EB',
	  purple: '#722ED1',
	  magenta: '#EB2F96',
	  grey: '#666666'
	};
	var presetPalettes = {};
	var presetDarkPalettes = {};
	Object.keys(presetPrimaryColors).forEach(function (key) {
	  presetPalettes[key] = generate$1(presetPrimaryColors[key]);
	  presetPalettes[key].primary = presetPalettes[key][5]; // dark presetPalettes

	  presetDarkPalettes[key] = generate$1(presetPrimaryColors[key], {
	    theme: 'dark',
	    backgroundColor: '#141414'
	  });
	  presetDarkPalettes[key].primary = presetDarkPalettes[key][5];
	});
	var red = presetPalettes.red;
	var volcano = presetPalettes.volcano;
	var gold = presetPalettes.gold;
	var orange = presetPalettes.orange;
	var yellow = presetPalettes.yellow;
	var lime = presetPalettes.lime;
	var green = presetPalettes.green;
	var cyan = presetPalettes.cyan;
	var blue = presetPalettes.blue;
	var geekblue = presetPalettes.geekblue;
	var purple = presetPalettes.purple;
	var magenta = presetPalettes.magenta;
	var grey = presetPalettes.grey;

	var index_esm = /*#__PURE__*/Object.freeze({
		__proto__: null,
		blue: blue,
		cyan: cyan,
		geekblue: geekblue,
		generate: generate$1,
		gold: gold,
		green: green,
		grey: grey,
		lime: lime,
		magenta: magenta,
		orange: orange,
		presetDarkPalettes: presetDarkPalettes,
		presetPalettes: presetPalettes,
		presetPrimaryColors: presetPrimaryColors,
		purple: purple,
		red: red,
		volcano: volcano,
		yellow: yellow
	});

	var require$$4 = /*@__PURE__*/getAugmentedNamespace(index_esm);

	var warning$2 = {};

	Object.defineProperty(warning$2, "__esModule", {
	  value: true
	});
	warning$2.call = call;
	warning$2.default = void 0;
	warning$2.note = note;
	warning$2.noteOnce = noteOnce;
	warning$2.resetWarned = resetWarned;
	warning$2.warning = warning$1;
	warning$2.warningOnce = warningOnce;

	/* eslint-disable no-console */
	var warned = {};

	function warning$1(valid, message) {
	  // Support uglify
	  if (!valid && console !== undefined) {
	    console.error("Warning: ".concat(message));
	  }
	}

	function note(valid, message) {
	  // Support uglify
	  if (!valid && console !== undefined) {
	    console.warn("Note: ".concat(message));
	  }
	}

	function resetWarned() {
	  warned = {};
	}

	function call(method, valid, message) {
	  if (!valid && !warned[message]) {
	    method(false, message);
	    warned[message] = true;
	  }
	}

	function warningOnce(valid, message) {
	  call(warning$1, valid, message);
	}

	function noteOnce(valid, message) {
	  call(note, valid, message);
	}

	var _default$5 = warningOnce;
	/* eslint-enable */

	warning$2.default = _default$5;

	var dynamicCSS = {};

	var interopRequireDefault = {exports: {}};

	(function (module) {
	function _interopRequireDefault(obj) {
	  return obj && obj.__esModule ? obj : {
	    "default": obj
	  };
	}

	module.exports = _interopRequireDefault, module.exports.__esModule = true, module.exports["default"] = module.exports;
	}(interopRequireDefault));

	var canUseDom$1 = {};

	Object.defineProperty(canUseDom$1, "__esModule", {
	  value: true
	});
	canUseDom$1.default = canUseDom;

	function canUseDom() {
	  return !!(typeof window !== 'undefined' && window.document && window.document.createElement);
	}

	var _interopRequireDefault$7 = interopRequireDefault.exports;

	Object.defineProperty(dynamicCSS, "__esModule", {
	  value: true
	});
	dynamicCSS.injectCSS = injectCSS;
	dynamicCSS.removeCSS = removeCSS;
	dynamicCSS.updateCSS = updateCSS;

	var _canUseDom = _interopRequireDefault$7(canUseDom$1);

	var MARK_KEY = "rc-util-key";

	function getMark() {
	  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
	      mark = _ref.mark;

	  if (mark) {
	    return mark.startsWith('data-') ? mark : "data-".concat(mark);
	  }

	  return MARK_KEY;
	}

	function getContainer(option) {
	  if (option.attachTo) {
	    return option.attachTo;
	  }

	  var head = document.querySelector('head');
	  return head || document.body;
	}

	function injectCSS(css) {
	  var _option$csp;

	  var option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

	  if (!(0, _canUseDom.default)()) {
	    return null;
	  }

	  var styleNode = document.createElement('style');

	  if ((_option$csp = option.csp) === null || _option$csp === void 0 ? void 0 : _option$csp.nonce) {
	    var _option$csp2;

	    styleNode.nonce = (_option$csp2 = option.csp) === null || _option$csp2 === void 0 ? void 0 : _option$csp2.nonce;
	  }

	  styleNode.innerHTML = css;
	  var container = getContainer(option);
	  var firstChild = container.firstChild;

	  if (option.prepend && container.prepend) {
	    // Use `prepend` first
	    container.prepend(styleNode);
	  } else if (option.prepend && firstChild) {
	    // Fallback to `insertBefore` like IE not support `prepend`
	    container.insertBefore(styleNode, firstChild);
	  } else {
	    container.appendChild(styleNode);
	  }

	  return styleNode;
	}

	var containerCache = new Map();

	function findExistNode(key) {
	  var option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
	  var container = getContainer(option);
	  return Array.from(containerCache.get(container).children).find(function (node) {
	    return node.tagName === 'STYLE' && node.getAttribute(getMark(option)) === key;
	  });
	}

	function removeCSS(key) {
	  var _existNode$parentNode;

	  var option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
	  var existNode = findExistNode(key, option);
	  existNode === null || existNode === void 0 ? void 0 : (_existNode$parentNode = existNode.parentNode) === null || _existNode$parentNode === void 0 ? void 0 : _existNode$parentNode.removeChild(existNode);
	}

	function updateCSS(css, key) {
	  var option = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
	  var container = getContainer(option); // Get real parent

	  if (!containerCache.has(container)) {
	    var placeholderStyle = injectCSS('', option);
	    var parentNode = placeholderStyle.parentNode;
	    containerCache.set(container, parentNode);
	    parentNode.removeChild(placeholderStyle);
	  }

	  var existNode = findExistNode(key, option);

	  if (existNode) {
	    var _option$csp3, _option$csp4;

	    if (((_option$csp3 = option.csp) === null || _option$csp3 === void 0 ? void 0 : _option$csp3.nonce) && existNode.nonce !== ((_option$csp4 = option.csp) === null || _option$csp4 === void 0 ? void 0 : _option$csp4.nonce)) {
	      var _option$csp5;

	      existNode.nonce = (_option$csp5 = option.csp) === null || _option$csp5 === void 0 ? void 0 : _option$csp5.nonce;
	    }

	    if (existNode.innerHTML !== css) {
	      existNode.innerHTML = css;
	    }

	    return existNode;
	  }

	  var newNode = injectCSS(css, option);
	  newNode.setAttribute(getMark(option), key);
	  return newNode;
	}

	var _interopRequireWildcard$4 = interopRequireWildcard.exports;

	var _interopRequireDefault$6 = interopRequireDefault$1.exports;

	Object.defineProperty(utils, "__esModule", {
	  value: true
	});
	utils.warning = warning;
	utils.isIconDefinition = isIconDefinition;
	utils.normalizeAttrs = normalizeAttrs;
	utils.generate = generate;
	utils.getSecondaryColor = getSecondaryColor;
	utils.normalizeTwoToneColors = normalizeTwoToneColors;
	utils.useInsertStyles = utils.iconStyles = utils.svgBaseProps = void 0;

	var _objectSpread2$5 = _interopRequireDefault$6(objectSpread2.exports);

	var _typeof2 = _interopRequireDefault$6(_typeof.exports);

	var _colors = require$$4;

	var _react = _interopRequireWildcard$4(React__default["default"]);

	var _warning = _interopRequireDefault$6(warning$2);

	var _dynamicCSS = dynamicCSS;

	var _Context$1 = _interopRequireDefault$6(Context);

	function warning(valid, message) {
	  (0, _warning.default)(valid, "[@ant-design/icons] ".concat(message));
	}

	function isIconDefinition(target) {
	  return (0, _typeof2.default)(target) === 'object' && typeof target.name === 'string' && typeof target.theme === 'string' && ((0, _typeof2.default)(target.icon) === 'object' || typeof target.icon === 'function');
	}

	function normalizeAttrs() {
	  var attrs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
	  return Object.keys(attrs).reduce(function (acc, key) {
	    var val = attrs[key];

	    switch (key) {
	      case 'class':
	        acc.className = val;
	        delete acc.class;
	        break;

	      default:
	        acc[key] = val;
	    }

	    return acc;
	  }, {});
	}

	function generate(node, key, rootProps) {
	  if (!rootProps) {
	    return /*#__PURE__*/_react.default.createElement(node.tag, (0, _objectSpread2$5.default)({
	      key: key
	    }, normalizeAttrs(node.attrs)), (node.children || []).map(function (child, index) {
	      return generate(child, "".concat(key, "-").concat(node.tag, "-").concat(index));
	    }));
	  }

	  return /*#__PURE__*/_react.default.createElement(node.tag, (0, _objectSpread2$5.default)((0, _objectSpread2$5.default)({
	    key: key
	  }, normalizeAttrs(node.attrs)), rootProps), (node.children || []).map(function (child, index) {
	    return generate(child, "".concat(key, "-").concat(node.tag, "-").concat(index));
	  }));
	}

	function getSecondaryColor(primaryColor) {
	  // choose the second color
	  return (0, _colors.generate)(primaryColor)[0];
	}

	function normalizeTwoToneColors(twoToneColor) {
	  if (!twoToneColor) {
	    return [];
	  }

	  return Array.isArray(twoToneColor) ? twoToneColor : [twoToneColor];
	} // These props make sure that the SVG behaviours like general text.
	// Reference: https://blog.prototypr.io/align-svg-icons-to-text-and-say-goodbye-to-font-icons-d44b3d7b26b4


	var svgBaseProps = {
	  width: '1em',
	  height: '1em',
	  fill: 'currentColor',
	  'aria-hidden': 'true',
	  focusable: 'false'
	};
	utils.svgBaseProps = svgBaseProps;
	var iconStyles = "\n.anticon {\n  display: inline-block;\n  color: inherit;\n  font-style: normal;\n  line-height: 0;\n  text-align: center;\n  text-transform: none;\n  vertical-align: -0.125em;\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n}\n\n.anticon > * {\n  line-height: 1;\n}\n\n.anticon svg {\n  display: inline-block;\n}\n\n.anticon::before {\n  display: none;\n}\n\n.anticon .anticon-icon {\n  display: block;\n}\n\n.anticon[tabindex] {\n  cursor: pointer;\n}\n\n.anticon-spin::before,\n.anticon-spin {\n  display: inline-block;\n  -webkit-animation: loadingCircle 1s infinite linear;\n  animation: loadingCircle 1s infinite linear;\n}\n\n@-webkit-keyframes loadingCircle {\n  100% {\n    -webkit-transform: rotate(360deg);\n    transform: rotate(360deg);\n  }\n}\n\n@keyframes loadingCircle {\n  100% {\n    -webkit-transform: rotate(360deg);\n    transform: rotate(360deg);\n  }\n}\n";
	utils.iconStyles = iconStyles;

	var useInsertStyles = function useInsertStyles() {
	  var styleStr = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : iconStyles;

	  var _useContext = (0, _react.useContext)(_Context$1.default),
	      csp = _useContext.csp;

	  (0, _react.useEffect)(function () {
	    (0, _dynamicCSS.updateCSS)(styleStr, '@ant-design-icons', {
	      prepend: true,
	      csp: csp
	    });
	  }, []);
	};

	utils.useInsertStyles = useInsertStyles;

	var _interopRequireDefault$5 = interopRequireDefault$1.exports;

	Object.defineProperty(IconBase$1, "__esModule", {
	  value: true
	});
	IconBase$1.default = void 0;

	var _objectWithoutProperties2$1 = _interopRequireDefault$5(objectWithoutProperties.exports);

	var _objectSpread2$4 = _interopRequireDefault$5(objectSpread2.exports);

	var _utils$2 = utils;

	var _excluded$1 = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"];
	var twoToneColorPalette = {
	  primaryColor: '#333',
	  secondaryColor: '#E6E6E6',
	  calculated: false
	};

	function setTwoToneColors(_ref) {
	  var primaryColor = _ref.primaryColor,
	      secondaryColor = _ref.secondaryColor;
	  twoToneColorPalette.primaryColor = primaryColor;
	  twoToneColorPalette.secondaryColor = secondaryColor || (0, _utils$2.getSecondaryColor)(primaryColor);
	  twoToneColorPalette.calculated = !!secondaryColor;
	}

	function getTwoToneColors() {
	  return (0, _objectSpread2$4.default)({}, twoToneColorPalette);
	}

	var IconBase = function IconBase(props) {
	  var icon = props.icon,
	      className = props.className,
	      onClick = props.onClick,
	      style = props.style,
	      primaryColor = props.primaryColor,
	      secondaryColor = props.secondaryColor,
	      restProps = (0, _objectWithoutProperties2$1.default)(props, _excluded$1);
	  var colors = twoToneColorPalette;

	  if (primaryColor) {
	    colors = {
	      primaryColor: primaryColor,
	      secondaryColor: secondaryColor || (0, _utils$2.getSecondaryColor)(primaryColor)
	    };
	  }

	  (0, _utils$2.useInsertStyles)();
	  (0, _utils$2.warning)((0, _utils$2.isIconDefinition)(icon), "icon should be icon definiton, but got ".concat(icon));

	  if (!(0, _utils$2.isIconDefinition)(icon)) {
	    return null;
	  }

	  var target = icon;

	  if (target && typeof target.icon === 'function') {
	    target = (0, _objectSpread2$4.default)((0, _objectSpread2$4.default)({}, target), {}, {
	      icon: target.icon(colors.primaryColor, colors.secondaryColor)
	    });
	  }

	  return (0, _utils$2.generate)(target.icon, "svg-".concat(target.name), (0, _objectSpread2$4.default)({
	    className: className,
	    onClick: onClick,
	    style: style,
	    'data-icon': target.name,
	    width: '1em',
	    height: '1em',
	    fill: 'currentColor',
	    'aria-hidden': 'true'
	  }, restProps));
	};

	IconBase.displayName = 'IconReact';
	IconBase.getTwoToneColors = getTwoToneColors;
	IconBase.setTwoToneColors = setTwoToneColors;
	var _default$4 = IconBase;
	IconBase$1.default = _default$4;

	var twoTonePrimaryColor = {};

	var _interopRequireDefault$4 = interopRequireDefault$1.exports;

	Object.defineProperty(twoTonePrimaryColor, "__esModule", {
	  value: true
	});
	twoTonePrimaryColor.setTwoToneColor = setTwoToneColor;
	twoTonePrimaryColor.getTwoToneColor = getTwoToneColor;

	var _slicedToArray2$1 = _interopRequireDefault$4(slicedToArray.exports);

	var _IconBase$1 = _interopRequireDefault$4(IconBase$1);

	var _utils$1 = utils;

	function setTwoToneColor(twoToneColor) {
	  var _normalizeTwoToneColo = (0, _utils$1.normalizeTwoToneColors)(twoToneColor),
	      _normalizeTwoToneColo2 = (0, _slicedToArray2$1.default)(_normalizeTwoToneColo, 2),
	      primaryColor = _normalizeTwoToneColo2[0],
	      secondaryColor = _normalizeTwoToneColo2[1];

	  return _IconBase$1.default.setTwoToneColors({
	    primaryColor: primaryColor,
	    secondaryColor: secondaryColor
	  });
	}

	function getTwoToneColor() {
	  var colors = _IconBase$1.default.getTwoToneColors();

	  if (!colors.calculated) {
	    return colors.primaryColor;
	  }

	  return [colors.primaryColor, colors.secondaryColor];
	}

	var _interopRequireDefault$3 = interopRequireDefault$1.exports;

	var _interopRequireWildcard$3 = interopRequireWildcard.exports;

	Object.defineProperty(AntdIcon, "__esModule", {
	  value: true
	});
	AntdIcon.default = void 0;

	var _objectSpread2$3 = _interopRequireDefault$3(objectSpread2.exports);

	var _slicedToArray2 = _interopRequireDefault$3(slicedToArray.exports);

	var _defineProperty2 = _interopRequireDefault$3(defineProperty.exports);

	var _objectWithoutProperties2 = _interopRequireDefault$3(objectWithoutProperties.exports);

	var React$3 = _interopRequireWildcard$3(React__default["default"]);

	var _classnames = _interopRequireDefault$3(classnames.exports);

	var _Context = _interopRequireDefault$3(Context);

	var _IconBase = _interopRequireDefault$3(IconBase$1);

	var _twoTonePrimaryColor = twoTonePrimaryColor;

	var _utils = utils;

	var _excluded = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
	// Initial setting
	// should move it to antd main repo?
	(0, _twoTonePrimaryColor.setTwoToneColor)('#1890ff');
	var Icon = /*#__PURE__*/React$3.forwardRef(function (props, ref) {
	  var _classNames;

	  var className = props.className,
	      icon = props.icon,
	      spin = props.spin,
	      rotate = props.rotate,
	      tabIndex = props.tabIndex,
	      onClick = props.onClick,
	      twoToneColor = props.twoToneColor,
	      restProps = (0, _objectWithoutProperties2.default)(props, _excluded);

	  var _React$useContext = React$3.useContext(_Context.default),
	      _React$useContext$pre = _React$useContext.prefixCls,
	      prefixCls = _React$useContext$pre === void 0 ? 'anticon' : _React$useContext$pre;

	  var classString = (0, _classnames.default)(prefixCls, (_classNames = {}, (0, _defineProperty2.default)(_classNames, "".concat(prefixCls, "-").concat(icon.name), !!icon.name), (0, _defineProperty2.default)(_classNames, "".concat(prefixCls, "-spin"), !!spin || icon.name === 'loading'), _classNames), className);
	  var iconTabIndex = tabIndex;

	  if (iconTabIndex === undefined && onClick) {
	    iconTabIndex = -1;
	  }

	  var svgStyle = rotate ? {
	    msTransform: "rotate(".concat(rotate, "deg)"),
	    transform: "rotate(".concat(rotate, "deg)")
	  } : undefined;

	  var _normalizeTwoToneColo = (0, _utils.normalizeTwoToneColors)(twoToneColor),
	      _normalizeTwoToneColo2 = (0, _slicedToArray2.default)(_normalizeTwoToneColo, 2),
	      primaryColor = _normalizeTwoToneColo2[0],
	      secondaryColor = _normalizeTwoToneColo2[1];

	  return /*#__PURE__*/React$3.createElement("span", (0, _objectSpread2$3.default)((0, _objectSpread2$3.default)({
	    role: "img",
	    "aria-label": icon.name
	  }, restProps), {}, {
	    ref: ref,
	    tabIndex: iconTabIndex,
	    onClick: onClick,
	    className: classString
	  }), /*#__PURE__*/React$3.createElement(_IconBase.default, {
	    icon: icon,
	    primaryColor: primaryColor,
	    secondaryColor: secondaryColor,
	    style: svgStyle
	  }));
	});
	Icon.displayName = 'AntdIcon';
	Icon.getTwoToneColor = _twoTonePrimaryColor.getTwoToneColor;
	Icon.setTwoToneColor = _twoTonePrimaryColor.setTwoToneColor;
	var _default$3 = Icon;
	AntdIcon.default = _default$3;

	var _interopRequireWildcard$2 = interopRequireWildcard.exports;

	var _interopRequireDefault$2 = interopRequireDefault$1.exports;

	Object.defineProperty(InfoCircleOutlined$4, "__esModule", {
	  value: true
	});
	InfoCircleOutlined$4.default = void 0;

	var _objectSpread2$2 = _interopRequireDefault$2(objectSpread2.exports);

	var React$2 = _interopRequireWildcard$2(React__default["default"]);

	var _InfoCircleOutlined = _interopRequireDefault$2(InfoCircleOutlined$3);

	var _AntdIcon$2 = _interopRequireDefault$2(AntdIcon);

	// GENERATE BY ./scripts/generate.ts
	// DON NOT EDIT IT MANUALLY
	var InfoCircleOutlined$1 = function InfoCircleOutlined(props, ref) {
	  return /*#__PURE__*/React$2.createElement(_AntdIcon$2.default, (0, _objectSpread2$2.default)((0, _objectSpread2$2.default)({}, props), {}, {
	    ref: ref,
	    icon: _InfoCircleOutlined.default
	  }));
	};

	InfoCircleOutlined$1.displayName = 'InfoCircleOutlined';

	var _default$2 = /*#__PURE__*/React$2.forwardRef(InfoCircleOutlined$1);

	InfoCircleOutlined$4.default = _default$2;

	(function (module, exports) {
	  Object.defineProperty(exports, "__esModule", {
	    value: true
	  });
	  exports.default = void 0;
	  
	  var _InfoCircleOutlined = _interopRequireDefault(InfoCircleOutlined$4);
	  
	  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }
	  
	  var _default = _InfoCircleOutlined;
	  exports.default = _default;
	  module.exports = _default;
	}(InfoCircleOutlined$5, InfoCircleOutlined$5.exports));

	var InfoCircleOutlined = /*@__PURE__*/getDefaultExportFromCjs(InfoCircleOutlined$5.exports);

	var CaretLeftOutlined$5 = {exports: {}};

	var CaretLeftOutlined$4 = {};

	var CaretLeftOutlined$3 = {};

	// This icon file is generated automatically.
	Object.defineProperty(CaretLeftOutlined$3, "__esModule", { value: true });
	var CaretLeftOutlined$2 = { "icon": { "tag": "svg", "attrs": { "viewBox": "0 0 1024 1024", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M689 165.1L308.2 493.5c-10.9 9.4-10.9 27.5 0 37L689 858.9c14.2 12.2 35 1.2 35-18.5V183.6c0-19.7-20.8-30.7-35-18.5z" } }] }, "name": "caret-left", "theme": "outlined" };
	CaretLeftOutlined$3.default = CaretLeftOutlined$2;

	var _interopRequireWildcard$1 = interopRequireWildcard.exports;

	var _interopRequireDefault$1 = interopRequireDefault$1.exports;

	Object.defineProperty(CaretLeftOutlined$4, "__esModule", {
	  value: true
	});
	CaretLeftOutlined$4.default = void 0;

	var _objectSpread2$1 = _interopRequireDefault$1(objectSpread2.exports);

	var React$1 = _interopRequireWildcard$1(React__default["default"]);

	var _CaretLeftOutlined = _interopRequireDefault$1(CaretLeftOutlined$3);

	var _AntdIcon$1 = _interopRequireDefault$1(AntdIcon);

	// GENERATE BY ./scripts/generate.ts
	// DON NOT EDIT IT MANUALLY
	var CaretLeftOutlined$1 = function CaretLeftOutlined(props, ref) {
	  return /*#__PURE__*/React$1.createElement(_AntdIcon$1.default, (0, _objectSpread2$1.default)((0, _objectSpread2$1.default)({}, props), {}, {
	    ref: ref,
	    icon: _CaretLeftOutlined.default
	  }));
	};

	CaretLeftOutlined$1.displayName = 'CaretLeftOutlined';

	var _default$1 = /*#__PURE__*/React$1.forwardRef(CaretLeftOutlined$1);

	CaretLeftOutlined$4.default = _default$1;

	(function (module, exports) {
	  Object.defineProperty(exports, "__esModule", {
	    value: true
	  });
	  exports.default = void 0;
	  
	  var _CaretLeftOutlined = _interopRequireDefault(CaretLeftOutlined$4);
	  
	  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }
	  
	  var _default = _CaretLeftOutlined;
	  exports.default = _default;
	  module.exports = _default;
	}(CaretLeftOutlined$5, CaretLeftOutlined$5.exports));

	var CaretLeftOutlined = /*@__PURE__*/getDefaultExportFromCjs(CaretLeftOutlined$5.exports);

	var CaretRightOutlined$5 = {exports: {}};

	var CaretRightOutlined$4 = {};

	var CaretRightOutlined$3 = {};

	// This icon file is generated automatically.
	Object.defineProperty(CaretRightOutlined$3, "__esModule", { value: true });
	var CaretRightOutlined$2 = { "icon": { "tag": "svg", "attrs": { "viewBox": "0 0 1024 1024", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M715.8 493.5L335 165.1c-14.2-12.2-35-1.2-35 18.5v656.8c0 19.7 20.8 30.7 35 18.5l380.8-328.4c10.9-9.4 10.9-27.6 0-37z" } }] }, "name": "caret-right", "theme": "outlined" };
	CaretRightOutlined$3.default = CaretRightOutlined$2;

	var _interopRequireWildcard = interopRequireWildcard.exports;

	var _interopRequireDefault = interopRequireDefault$1.exports;

	Object.defineProperty(CaretRightOutlined$4, "__esModule", {
	  value: true
	});
	CaretRightOutlined$4.default = void 0;

	var _objectSpread2 = _interopRequireDefault(objectSpread2.exports);

	var React = _interopRequireWildcard(React__default["default"]);

	var _CaretRightOutlined = _interopRequireDefault(CaretRightOutlined$3);

	var _AntdIcon = _interopRequireDefault(AntdIcon);

	// GENERATE BY ./scripts/generate.ts
	// DON NOT EDIT IT MANUALLY
	var CaretRightOutlined$1 = function CaretRightOutlined(props, ref) {
	  return /*#__PURE__*/React.createElement(_AntdIcon.default, (0, _objectSpread2.default)((0, _objectSpread2.default)({}, props), {}, {
	    ref: ref,
	    icon: _CaretRightOutlined.default
	  }));
	};

	CaretRightOutlined$1.displayName = 'CaretRightOutlined';

	var _default = /*#__PURE__*/React.forwardRef(CaretRightOutlined$1);

	CaretRightOutlined$4.default = _default;

	(function (module, exports) {
	  Object.defineProperty(exports, "__esModule", {
	    value: true
	  });
	  exports.default = void 0;
	  
	  var _CaretRightOutlined = _interopRequireDefault(CaretRightOutlined$4);
	  
	  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }
	  
	  var _default = _CaretRightOutlined;
	  exports.default = _default;
	  module.exports = _default;
	}(CaretRightOutlined$5, CaretRightOutlined$5.exports));

	var CaretRightOutlined = /*@__PURE__*/getDefaultExportFromCjs(CaretRightOutlined$5.exports);

	/**
	 * Abstraction for localStorage that uses an in-memory fallback when localStorage throws an error.
	 * Reasons for throwing an error:
	 * - maximum quota is exceeded
	 * - under Mobile Safari (since iOS 5) when the user enters private mode `localStorage.setItem()`
	 *   will throw
	 * - trying to access localStorage object when cookies are disabled in Safari throws
	 *   "SecurityError: The operation is insecure."
	 */
	var storage = {
	    data: new Map(),
	    get(key, defaultValue) {
	        try {
	            return this.data.has(key)
	                ? this.data.get(key)
	                : parseJSON(localStorage.getItem(key));
	        }
	        catch (_a) {
	            return defaultValue;
	        }
	    },
	    set(key, value) {
	        try {
	            localStorage.setItem(key, JSON.stringify(value));
	            this.data.delete(key);
	        }
	        catch (_a) {
	            this.data.set(key, value);
	        }
	    },
	    remove(key) {
	        this.data.delete(key);
	        localStorage.removeItem(key);
	    },
	};
	/**
	 * A wrapper for `JSON.parse()` which supports the return value of `JSON.stringify(undefined)`
	 * which returns the string `"undefined"` and this method returns the value `undefined`.
	 */
	function parseJSON(value) {
	    return value === 'undefined'
	        ? undefined
	        : // - `JSON.parse()` TypeScript types don't accept non-string values, this is why we pass
	            //   empty string which will throw an error
	            // - when `value` is `null`, we will pass empty string and the `JSON.parse()` will throw
	            //   an error which we need and is required by the parent function
	            JSON.parse(value !== null && value !== void 0 ? value : '');
	}

	// `activeHooks` holds all active hooks. we use the array to update all hooks with the same key —
	// calling `setValue` of one hook triggers an update for all other hooks with the same key
	const activeHooks = new Set();
	function useLocalStorageState(key, options) {
	    const defaultValue = options === null || options === void 0 ? void 0 : options.defaultValue;
	    // SSR support
	    if (typeof window === 'undefined') {
	        return [defaultValue, () => { }, { isPersistent: true, removeItem: () => { } }];
	    }
	    // eslint-disable-next-line react-hooks/rules-of-hooks
	    return useClientLocalStorageState(key, defaultValue, (options === null || options === void 0 ? void 0 : options.ssr) === true);
	}
	function useClientLocalStorageState(key, defaultValue, ssr) {
	    const initialDefaultValue = React$4.useRef(defaultValue).current;
	    // `id` changes every time a change in the `localStorage` occurs
	    const [id, forceUpdate] = React$4.useReducer((number) => number + 1, 0);
	    const updateHooks = React$4.useCallback(() => {
	        reactDom.unstable_batchedUpdates(() => {
	            for (const hook of activeHooks) {
	                if (hook.key === key) {
	                    hook.forceUpdate();
	                }
	            }
	        });
	    }, [key]);
	    const setState = React$4.useCallback((newValue) => {
	        storage.set(key, newValue instanceof Function
	            ? newValue(storage.get(key, initialDefaultValue))
	            : newValue);
	        updateHooks();
	    }, [key, updateHooks, initialDefaultValue]);
	    // - syncs change across tabs, windows, iframe's
	    // - the `storage` event is called only in all tabs, windows, iframe's except the one that
	    //   triggered the change
	    React$4.useEffect(() => {
	        const onStorage = (e) => {
	            if (e.storageArea === localStorage && e.key === key) {
	                forceUpdate();
	            }
	        };
	        window.addEventListener('storage', onStorage);
	        return () => window.removeEventListener('storage', onStorage);
	    }, [key]);
	    // - adds this hook to the `activeHooks` array. see the `activeHooks` declaration above for a
	    //   more detailed explanation
	    // - not inside a React effect because:
	    //   - it fixes "🐛 `setValue()` during render doesn't work":
	    //     https://github.com/astoilkov/use-local-storage-state/issues/43
	    //   - if you call `setValue()` during render and you have two localStorage instances with the
	    //     same key — React throws an error. we want this behavior because otherwise it will just
	    //     silently fail
	    const activeHookRef = React$4.useRef({ key, forceUpdate });
	    activeHooks.add(activeHookRef.current);
	    React$4.useEffect(() => () => {
	        activeHooks.delete(activeHookRef.current);
	    }, []);
	    // - SSR support
	    // - not inside a `useLayoutEffect` because this way we skip the calls to `useEffect()` and
	    //   `useLayoutEffect()` for the first render (which also increases performance)
	    // - inspired by: https://github.com/astoilkov/use-local-storage-state/pull/40
	    // - related: https://github.com/astoilkov/use-local-storage-state/issues/39
	    // - related: https://github.com/astoilkov/use-local-storage-state/issues/43
	    const isFirstRenderRef = React$4.useRef(true);
	    const isPossiblyHydrating = ssr && isFirstRenderRef.current;
	    isFirstRenderRef.current = false;
	    if (isPossiblyHydrating &&
	        (storage.data.has(key) || initialDefaultValue !== storage.get(key, initialDefaultValue))) {
	        forceUpdate();
	    }
	    // initial issue: https://github.com/astoilkov/use-local-storage-state/issues/26
	    // issues that were caused by incorrect initial and secondary implementations:
	    // - https://github.com/astoilkov/use-local-storage-state/issues/30
	    // - https://github.com/astoilkov/use-local-storage-state/issues/33
	    if (initialDefaultValue !== undefined &&
	        !storage.data.has(key) &&
	        localStorage.getItem(key) === null) {
	        storage.set(key, initialDefaultValue);
	    }
	    return React$4.useMemo(() => [
	        isPossiblyHydrating ? initialDefaultValue : storage.get(key, initialDefaultValue),
	        setState,
	        {
	            isPersistent: isPossiblyHydrating || !storage.data.has(key),
	            removeItem() {
	                storage.remove(key);
	                updateHooks();
	            },
	        },
	    ], 
	    // disabling eslint warning for the following reasons:
	    // - `id` is needed because when it changes that means the data in `localStorage` has
	    //   changed and we need to update the returned value. However, the eslint rule wants us to
	    //   remove the `id` from the dependencies array.
	    // - `defaultValue` never changes so we can skip it and reduce package size
	    // - `setState` changes when `key` changes so we can skip it and reduce package size
	    // eslint-disable-next-line react-hooks/exhaustive-deps
	    [id, key]);
	}

	var __defProp = Object.defineProperty;
	var __defProps = Object.defineProperties;
	var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
	var __getOwnPropSymbols = Object.getOwnPropertySymbols;
	var __hasOwnProp = Object.prototype.hasOwnProperty;
	var __propIsEnum = Object.prototype.propertyIsEnumerable;
	var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
	var __spreadValues = (a, b) => {
	  for (var prop in b || (b = {}))
	    if (__hasOwnProp.call(b, prop))
	      __defNormalProp(a, prop, b[prop]);
	  if (__getOwnPropSymbols)
	    for (var prop of __getOwnPropSymbols(b)) {
	      if (__propIsEnum.call(b, prop))
	        __defNormalProp(a, prop, b[prop]);
	    }
	  return a;
	};
	var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
	var __objRest = (source, exclude) => {
	  var target = {};
	  for (var prop in source)
	    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
	      target[prop] = source[prop];
	  if (source != null && __getOwnPropSymbols)
	    for (var prop of __getOwnPropSymbols(source)) {
	      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
	        target[prop] = source[prop];
	    }
	  return target;
	};
	const Rank = styled.span`
  display: inline-block;
  font-size: 14px;
  width: 24px;
  height: 24px;
  line-height: 24px;
  border-radius: 24px;
  text-align: center;
  margin-right: 10px;
  background: ${(props) => props.color};
`;
	styled(InfoCircleOutlined)`
  position: absolute;
  top: 5px;
  right: 5px;
`;
	const StyledTable = styled(antd.Table)`
  width: 100% !important;
  border-right: ${(props) => props.isCompareMode ? 1 : 0}px solid ${(props) => props.color[0]} !important;
  .ant-table {
    background: ${(props) => props.color[3]} !important;
  }
  .ant-table-thead > tr > th {
    background: ${(props) => props.color[0]} !important;
    border-right: 1px solid rgba(0, 0, 0, 0.2);
    border-bottom: 1px solid rgba(0, 0, 0, 0.2);
    text-align: center;
    padding: '5px' !important;
    &.ant-table-cell-scrollbar {
      border-right: 0;
    }
    .ant-table-header-column {
      white-space: nowrap;
    }
  }
  .ant-table-thead > tr > th,
  .ant-table-tbody > tr > td {
    border-bottom: 1px solid ${(props) => props.color[0]};
    border-right: 1px solid ${(props) => props.color[0]};
    text-align: center;
    max-width: 150px;
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
    width: ${(props) => props.columnWidth}px !important;
  }
  .ant-table-thead > tr:first-child > th:first-child {
    border-left: 1px solid ${(props) => props.color[0]};
  }
  .ant-table-thead > tr > th {
    color: ${(props) => props.color[1]};
  }
  .ant-table-tbody > tr > td {
    color: ${(props) => props.color[5]};
  }
  .ant-table-tbody > tr:hover > td {
    background: ${(props) => props.color[4]};
  }
  .ant-table-tbody > tr > td:first-child {
    text-align: left;
    border-left: 1px solid ${(props) => props.color[0]};
  }
  .ant-table-cell-fix-left,
  .ant-table-cell-fix-right {
    /* background: ${(props) => props.color[0]} !important; */
  }
  .ant-table-fixed {
    /* background: ${(props) => props.color[0]} !important; */
  }
  .ant-table-thead
    > tr.ant-table-row-hover:not(.ant-table-expanded-row):not(.ant-table-row-selected)
    > td,
  .ant-table-tbody
    > tr.ant-table-row-hover:not(.ant-table-expanded-row):not(.ant-table-row-selected)
    > td {
    background: ${(props) => props.color[0]} !important;
  }
  .ant-table-fixed-left {
    width: ${(props) => {
  return props.dimensionCount * props.columnWidth;
}}px;
  }
  .columnTitleCell {
    position: relative;
    &:hover {
      & > .sortBtn {
        opacity: 1;
        visibility: visible;
      }
    }
  }
`;
	const ValueCell = styled.span`
  color: ${(props) => props.isSum ? props.colors && props.colors[2] || "color: rgba(0, 0, 0, 0.65)" : "color: rgba(0, 0, 0, 0.65)"};
`;
	const TitleSortLeft = styled.span`
  position: absolute;
  left: 0;
  top: 0;
  opacity: 0;
  visibility: hidden;
  transition: opacity 0.3s ease;
  padding: 0 5px;
  height: 100%;
  display: flex;
  justify-content: center;
  align-items: center;
  cursor: pointer;
  background: rgba(0, 0, 0, 0.3);
  color: #fff;
`;
	const TitleSortRight = styled.span`
  position: absolute;
  right: 0;
  top: 0;
  opacity: 0;
  visibility: hidden;
  transition: opacity 0.3s ease;
  padding: 0 5px;
  height: 100%;
  display: flex;
  justify-content: center;
  align-items: center;
  cursor: pointer;
  background: rgba(0, 0, 0, 0.3);
  color: #fff;
`;
	const Table = (props) => {
	  const _a = props, {
	    context,
	    dimension = [],
	    compareDimension,
	    valueList = [],
	    colorList = ["#fafafa"],
	    showRank,
	    showSum,
	    hideDimensionCompareTitle,
	    blockWrapHeight = 500,
	    antdOptions,
	    sortKey,
	    columnWidth,
	    setTableOption
	  } = _a; __objRest(_a, [
	    "context",
	    "dimension",
	    "compareDimension",
	    "valueList",
	    "colorList",
	    "showRank",
	    "showSum",
	    "hideDimensionCompareTitle",
	    "blockWrapHeight",
	    "antdOptions",
	    "sortKey",
	    "columnWidth",
	    "setTableOption"
	  ]);
	  const { data } = React$4.useContext(context);
	  const COLUMN_WIDTH = columnWidth || 150;
	  if (!data) {
	    return null;
	  }
	  const colors = colorList || COLOR_LIST;
	  const [moveItem, setMoveItem] = React$4.useState(null);
	  const [moveUpdateKey, setMoveUpdateKey] = React$4.useState(null);
	  const [sortedTableColumnsKeys, setSortedTableColumnsKeys] = useLocalStorageState(`[@echarts-readymade/table]sortedTableColumnsKeys-${sortKey}`, {
	    defaultValue: []
	  });
	  const getColSpan = (text, index, dimAndVal, fieldKey) => {
	    let count = 1;
	    for (let i = index; i < dimAndVal.length; i++) {
	      const d = dimAndVal[i];
	      if (d.fieldKey === fieldKey && d.fieldName == text && text != null) {
	        count++;
	      } else {
	        break;
	      }
	    }
	    return count;
	  };
	  const tableColumns = () => {
	    const dimensionListAndValueList = [...dimension, ...valueList];
	    if (compareDimension && compareDimension.length > 0) {
	      let columns = [...new Set(data.map((d) => d[compareDimension[0].fieldKey]))];
	      if (showSum) {
	        columns = ["\u603B\u8BA1", ...columns];
	      }
	      const getColumn = (v, index, item, c, isShowCompareColumnTitle) => {
	        return {
	          title: isShowCompareColumnTitle ? /* @__PURE__ */ React__default["default"].createElement("span", {
	            title: c
	          }, c) : /* @__PURE__ */ React__default["default"].createElement("span", {
	            title: v.fieldName
	          }, v.fieldName),
	          key: `${v.fieldKey}_${index}`,
	          dataIndex: v.fieldKey,
	          width: v.width || COLUMN_WIDTH,
	          render: (text, row, i) => {
	            if (c == "\u603B\u8BA1" && i == 0) {
	              return "";
	            }
	            const { compareList } = row;
	            const itemOfColumn = compareList.find((compareListItem) => compareListItem.name == c) || {};
	            let _value = itemOfColumn[v.fieldKey] != null ? itemOfColumn[v.fieldKey] : "";
	            if (v.isPercent) {
	              try {
	                _value = itemOfColumn[v.fieldKey] != null && !isNaN(itemOfColumn[v.fieldKey]) ? `${numberWithCommas((parseFloat(itemOfColumn[v.fieldKey]) * 100).toFixed(v.decimalLength || 0))}%` : "";
	              } catch (e) {
	                _value = itemOfColumn[v.fieldKey] != null ? itemOfColumn[v.fieldKey] : "";
	              }
	            } else {
	              try {
	                _value = itemOfColumn[v.fieldKey] != null ? numberWithCommas(itemOfColumn[v.fieldKey].toFixed(v.decimalLength || 0)) : "";
	              } catch (e) {
	                _value = itemOfColumn[v.fieldKey] != null ? itemOfColumn[v.fieldKey] : "";
	              }
	            }
	            return /* @__PURE__ */ React__default["default"].createElement(ValueCell, {
	              title: _value,
	              colors,
	              isSum: c == "\u603B\u8BA1" || (dimension[0] && row[dimension[0].fieldKey]) == "\u603B\u8BA1"
	            }, _value);
	          }
	        };
	      };
	      const dimensionListCompareColumn = compareDimension.map((item) => {
	        return columns.map((c, index) => {
	          if (valueList.length == 1 && hideDimensionCompareTitle) {
	            return getColumn(valueList[0], index, item, c, true);
	          } else {
	            let _c = c;
	            return {
	              key: _c,
	              className: "columnTitleCell",
	              title: /* @__PURE__ */ React__default["default"].createElement(React__default["default"].Fragment, null, /* @__PURE__ */ React__default["default"].createElement(TitleSortLeft, {
	                className: "sortBtn",
	                onClick: () => {
	                  setMoveItem({ key: _c, direction: "left", hasCompare: true });
	                  setMoveUpdateKey(+new Date());
	                }
	              }, /* @__PURE__ */ React__default["default"].createElement(CaretLeftOutlined, null)), /* @__PURE__ */ React__default["default"].createElement("span", {
	                title: _c
	              }, _c), /* @__PURE__ */ React__default["default"].createElement(TitleSortRight, {
	                className: "sortBtn",
	                onClick: () => {
	                  setMoveItem({ key: _c, direction: "right", hasCompare: true });
	                  setMoveUpdateKey(+new Date());
	                }
	              }, /* @__PURE__ */ React__default["default"].createElement(CaretRightOutlined, null))),
	              children: valueList.map((v) => {
	                return getColumn(v, index, item, c, false);
	              })
	            };
	          }
	        });
	      });
	      let originColumns = [...dimensionListCompareColumn[0] || []];
	      const sortedColumns = [];
	      (sortedTableColumnsKeys || []).forEach((key) => {
	        let found = false;
	        originColumns = originColumns.filter((item) => {
	          if (!found && item.key == key) {
	            sortedColumns.push(item);
	            found = true;
	            return false;
	          } else
	            return true;
	        });
	      });
	      const dimensionListColumns = [
	        ...dimension.map((item, i) => {
	          return {
	            key: item.fieldKey,
	            title: /* @__PURE__ */ React__default["default"].createElement("span", {
	              title: item.fieldName
	            }, item.fieldName),
	            dataIndex: item.fieldKey,
	            width: item.width || COLUMN_WIDTH,
	            fixed: "left",
	            render: (text, row, index) => {
	              let _value = "";
	              try {
	                _value = numberWithCommas(text.toFixed(item.decimalLength || 0));
	              } catch (e) {
	                _value = text;
	              }
	              return {
	                children: /* @__PURE__ */ React__default["default"].createElement(ValueCell, {
	                  title: _value,
	                  colors,
	                  isSum: row[dimension[0].fieldKey] == "\u603B\u8BA1"
	                }, i == 0 && showRank ? showSum ? index > 0 ? /* @__PURE__ */ React__default["default"].createElement(Rank, {
	                  color: colors[0]
	                }, index) : "" : /* @__PURE__ */ React__default["default"].createElement(Rank, {
	                  color: colors[0]
	                }, index + 1) : "", _value || ""),
	                props: {
	                  colSpan: getColSpan(text, index, dimensionListAndValueList, item.fieldKey)
	                }
	              };
	            }
	          };
	        })
	      ];
	      let returnColumns = sortedTableColumnsKeys ? [
	        ...dimensionListColumns,
	        ...sortedColumns,
	        ...originColumns
	      ].filter((item) => item != null) : [...dimensionListColumns, ...originColumns].filter((item) => item != null);
	      return returnColumns;
	    } else {
	      const sumColumn = showSum ? [
	        {
	          key: "sum",
	          title: "\u603B\u8BA1",
	          dataIndex: "sum",
	          width: COLUMN_WIDTH,
	          render: (text, row, index) => {
	            const isAllPercent = valueList.map((v) => {
	              return v.isPercent;
	            }).filter((item) => !item).length == 0;
	            let _value = row.sum;
	            if (isAllPercent) {
	              _value = _value && !isNaN(_value) ? `${numberWithCommas((parseFloat(_value) * 100).toFixed(2))}%` : "";
	            } else {
	              _value = row.sum ? row.sum.toFixed(2) : "";
	            }
	            return /* @__PURE__ */ React__default["default"].createElement(ValueCell, {
	              title: text,
	              colors,
	              isSum: true
	            }, _value);
	          }
	        }
	      ] : [];
	      const mapFunc = (isDimensionList) => (item, i) => {
	        return {
	          key: item.fieldKey,
	          className: "columnTitleCell",
	          title: /* @__PURE__ */ React__default["default"].createElement(React__default["default"].Fragment, null, /* @__PURE__ */ React__default["default"].createElement("span", {
	            title: item.fieldName
	          }, item.fieldName)),
	          dataIndex: item.fieldKey,
	          width: item.width || COLUMN_WIDTH,
	          render: (text, row, index) => {
	            let _value = "";
	            if (item.isPercent) {
	              try {
	                _value = row[item.fieldKey] && !isNaN(text) ? `${numberWithCommas((parseFloat(text) * 100).toFixed(item.decimalLength || 0))}%` : "";
	              } catch (e) {
	                _value = text;
	              }
	            } else {
	              try {
	                _value = numberWithCommas(text.toFixed(item.decimalLength || 0));
	              } catch (e) {
	                _value = text;
	              }
	            }
	            return {
	              children: /* @__PURE__ */ React__default["default"].createElement(ValueCell, {
	                title: _value,
	                colors,
	                isSum: row[dimension[0].fieldKey] == "\u603B\u8BA1"
	              }, i == 0 && showRank && isDimensionList ? showSum ? index > 0 ? /* @__PURE__ */ React__default["default"].createElement(Rank, {
	                color: colors[0]
	              }, index) : "" : /* @__PURE__ */ React__default["default"].createElement(Rank, {
	                color: colors[0]
	              }, index + 1) : "", _value || ""),
	              props: {
	                colSpan: getColSpan(text, index, dimensionListAndValueList, item.fieldKey)
	              }
	            };
	          }
	        };
	      };
	      let originColumns = [
	        ...dimension.map(mapFunc(true)) || [],
	        ...sumColumn,
	        ...valueList.map(mapFunc(false)) || []
	      ].filter((item) => item != null);
	      return originColumns;
	    }
	  };
	  const tableData = () => {
	    const compareColumns2 = [
	      ...new Set(data.map((d) => d[compareDimension && compareDimension[0].fieldKey || ""]))
	    ];
	    valueList.map((item) => {
	      return item.fieldKey;
	    });
	    if (compareDimension && compareDimension.length > 0 && dimension.length > 0) {
	      let processData = function(_data2) {
	        var _a2, _b;
	        let tempPD = [];
	        for (let i = 0; i < _data2.length; i++) {
	          const d = _data2[i];
	          const progressDataItem = tempPD.find((pData) => {
	            let result = true;
	            dimension.forEach((dimension2) => {
	              if (pData[dimension2.fieldKey] != d[dimension2.fieldKey]) {
	                result = false;
	              }
	            });
	            return result;
	          });
	          if (progressDataItem) {
	            const _index = progressDataItem.compareList.findIndex((item) => item.name == d[compareDimension[0].fieldKey]);
	            valueList.forEach((v) => {
	              progressDataItem.compareList[_index][v.fieldKey] = d[v.fieldKey];
	            });
	            if (((_a2 = d.children) == null ? void 0 : _a2.length) > 0) {
	              progressDataItem.children = processData(d.children) || [];
	            } else {
	              progressDataItem.children = void 0;
	            }
	          } else {
	            const dimensions = {};
	            dimension.forEach((dim) => {
	              dimensions[dim.fieldKey] = d[dim.fieldKey];
	            });
	            const compareListSample = compareColumns2.map((item) => {
	              const _item = {
	                name: item
	              };
	              valueList.forEach((v) => {
	                _item[v.fieldKey] = null;
	              });
	              return _item;
	            });
	            const _index = compareListSample.findIndex((item) => item.name == d[compareDimension[0].fieldKey]);
	            valueList.forEach((v) => {
	              compareListSample[_index][v.fieldKey] = d[v.fieldKey];
	            });
	            tempPD.push(__spreadProps(__spreadValues({}, dimensions), {
	              compareList: compareListSample,
	              children: ((_b = d.children) == null ? void 0 : _b.length) > 0 ? processData(d.children) || [] : void 0
	            }));
	          }
	        }
	        return tempPD;
	      };
	      let progressData = [];
	      progressData = processData(data);
	      let sumRowData;
	      if (showSum) {
	        if (progressData.length > 0) {
	          sumRowData = cloneDeep(progressData[0]);
	          dimension.forEach((dim, i) => {
	            sumRowData[dim.fieldKey] = i == 0 ? "\u603B\u8BA1" : "";
	          });
	          sumRowData.compareList = compareColumns2.map((item) => {
	            const _item = {};
	            valueList.forEach((v) => {
	              _item[v.fieldKey] = 0;
	            });
	            _item.name = item;
	            return _item;
	          });
	          sumRowData = progressData.reduce((s, c) => {
	            s.compareList.forEach((item, i) => {
	              valueList.forEach((v) => {
	                s.compareList[i][v.fieldKey] = s.compareList[i][v.fieldKey] + (c.compareList[i] ? c.compareList[i][v.fieldKey] : 0);
	              });
	            });
	            return s;
	          }, sumRowData);
	        }
	        progressData = showSum ? [sumRowData, ...progressData] : progressData;
	        progressData = progressData.map((d) => {
	          const compareSum = cloneDeep(d.compareList[0]);
	          compareSum.name = "\u603B\u8BA1";
	          valueList.forEach((v) => {
	            compareSum[v.fieldKey] = 0;
	          });
	          d.compareList.slice(0, top).forEach((item) => {
	            valueList.forEach((v) => {
	              compareSum[v.fieldKey] = (compareSum[v.fieldKey] || 0) + (item[v.fieldKey] || 0);
	            });
	          });
	          d.compareList.push(compareSum);
	          return d;
	        });
	      }
	      const _data = progressData.map((item, i) => {
	        item.key = i;
	        return item;
	      });
	      return _data;
	    } else {
	      let sumRowData = {};
	      let _data = cloneDeep(data);
	      dimension.forEach((dim, i) => {
	        sumRowData[dim.fieldKey] = i == 0 ? "\u603B\u8BA1" : "";
	      });
	      valueList.forEach((v) => {
	        sumRowData[v.fieldKey] = 0;
	      });
	      sumRowData = _data.reduce((s, c) => {
	        valueList.forEach((v) => {
	          s[v.fieldKey] = (s[v.fieldKey] || 0) + c[v.fieldKey];
	        });
	        return s;
	      }, sumRowData);
	      _data = showSum ? [sumRowData, ...data] : data;
	      _data = _data.map((d) => {
	        d.sum = valueList.reduce((s, c) => {
	          return s + d[c.fieldKey];
	        }, 0);
	        return d;
	      });
	      const rdata = _data.map((item, i) => {
	        item.key = i;
	        return item;
	      });
	      return rdata;
	    }
	  };
	  const scroll = {};
	  const [rect, setRect] = React$4.useState(null);
	  const wrapperRef = React$4.useCallback((node) => {
	    if (node !== null) {
	      setRect(node.getBoundingClientRect());
	    }
	  }, []);
	  if (rect && rect.height < tableData().length * 53 + 50 + 40) {
	    scroll.y = blockWrapHeight - 40 - ((compareDimension && compareDimension.length > 0 ? 40 : 0) || 0);
	  }
	  const _blockWidth = rect == null ? void 0 : rect.width;
	  const compareColumns = [
	    ...new Set(data.map((d) => compareDimension && d[compareDimension[0].fieldKey]))
	  ];
	  if (compareDimension && compareDimension.length > 0) {
	    const _compareColumnsCount = Math.min(dimension.length - (showSum ? 1 : 0), compareColumns.length);
	    const dimensionWidth = valueList.reduce((s, c) => {
	      s = s + (c.width || COLUMN_WIDTH);
	      return s;
	    }, 0);
	    const valueListWidth = valueList.reduce((s, c) => {
	      s = s + (c.width || COLUMN_WIDTH);
	      return s;
	    }, 0);
	    if (_blockWidth < _compareColumnsCount * valueListWidth + dimensionWidth) {
	      scroll.x = _compareColumnsCount * valueListWidth + dimensionWidth;
	    }
	  } else {
	    if (_blockWidth < tableColumns().length * COLUMN_WIDTH + 100) {
	      scroll.x = "100%";
	    }
	  }
	  React$4.useEffect(() => {
	    if (moveItem) {
	      const _index = sortedTableColumnsKeys.findIndex((item) => item == moveItem.key);
	      if (moveItem.direction == "left") {
	        if (_index > 0) {
	          sortedTableColumnsKeys.splice(_index - 1, 0, sortedTableColumnsKeys.splice(_index, 1)[0]);
	          setSortedTableColumnsKeys(sortedTableColumnsKeys);
	        }
	      } else if (moveItem.direction == "right") {
	        if (_index < sortedTableColumnsKeys.length - 1) {
	          sortedTableColumnsKeys.splice(_index + 1, 0, sortedTableColumnsKeys.splice(_index, 1)[0]);
	          setSortedTableColumnsKeys(sortedTableColumnsKeys);
	        }
	      }
	      setMoveItem(null);
	    } else {
	      setSortedTableColumnsKeys(tableColumns().map((item) => item.key));
	    }
	  }, [moveUpdateKey]);
	  const options = {
	    columns: tableColumns(),
	    dataSource: tableData()
	  };
	  if (setTableOption) {
	    const { columns, dataSource } = setTableOption(options.columns, options.dataSource);
	    options.columns = columns;
	    options.dataSource = dataSource;
	  }
	  return /* @__PURE__ */ React__default["default"].createElement("div", {
	    ref: wrapperRef,
	    style: { height: blockWrapHeight || 500 }
	  }, /* @__PURE__ */ React__default["default"].createElement(StyledTable, __spreadValues({
	    size: "small",
	    color: colors,
	    dimensionCount: dimension.length,
	    columns: options.columns,
	    dataSource: options.dataSource,
	    pagination: false,
	    scroll,
	    columnWidth: COLUMN_WIDTH,
	    isCompareMode: compareDimension && compareDimension.length > 0
	  }, antdOptions)));
	};

	exports.Table = Table;

	Object.defineProperty(exports, '__esModule', { value: true });

}));
